      subroutine checkmodel(ddd,avdd,distmax)
      logical quit
      common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,
&     xmin,xmax,dz,dy,dx
      quit = .false.
      if(.not.(ola .lt. -90 .or. ola .gt. 90))goto 23000
      write(6,*) ''
      write(6,*) "latitude between -90,90"
      quit=.true. 
23000 continue
      if(.not.(olo .lt. -180 .or. olo .gt. 180))goto 23002
      write(6,*) ''
      write(6,*) "longitude between -180,180"
      quit=.true. 
23002 continue
      if(.not.(nz .lt. 2 .or. ny .lt. 2 .or. nx .lt. 2))goto 23004
      write(6,*) ''
      write(6,*) "nx,ny,nz should be at least 2"
      quit=.true. 
23004 continue
      nnx = nint((xmax-xmin)/dx) + 1
      nny = nint((ymax-ymin)/dy) + 1
      nnz = nint((zmax-zmin)/dz) + 1
      if(.not.(nz .ne. nnz .or. ny .ne. nny .or. nx .ne. nnx))goto 23006
      write(6,*) ''
      write(6,*) 
&     "nx,ny,nz not consistent with min,max values for x,y,z"
      write(6,*) "and with dx,dy,dz"
      quit=.true. 
23006 continue
      if(.not.(nsq .gt. 22e5))goto 23008
      write(6,*) ''
      write(6,*) 'nx*ny*nz too large, decrease nx,ny,nz'
      write(6,*) 
&     'or increase mxsq (NOT recommended because of limited memory)'
      quit=.true. 
23008 continue
      if(.not.(quit))goto 23010
      write(6,*) 'stop: change model.cube'
      stop
23010 continue
      ddd = (dx+dy+dz)/3.
      dmn = min(dx,dy,dz)
      dmx = max(dx,dy,dz)
      if(.not.(dmx .gt. 2.*dmn))goto 23012
      write(6,*) 'WARNING: knot-spacing varies too much in different'
      write(6,*) 'direction. Smoothing will possibly not work well.'
      write(6,*) 'Reminder: Earth is spherical and grid is cartesian'
23012 continue
      avdd = ddd/3.
      avdd = avdd/6371.
      avddtmp = avdd/1.74533e-2
      distmax = 557*avddtmp
      write(6,*) 'Note: your maximum epicentral distance should not'
      write(6,*) 'exceed ',distmax, ' degrees.'
      write(6,*) ''
      write(6,*) "avdd=",avddtmp," degr"
      return
      end
