subroutine checkmodel(ddd,avdd,distmax)
include defines

logical quit
common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,xmin,xmax,dz,dy,dx

quit = .false.
if (ola < -90 | ola > 90) {
   write(6,*) ''
   write(6,*) "latitude between -90,90"
   quit=.true. }
if (olo < -180 | olo > 180) {
   write(6,*) ''
   write(6,*) "longitude between -180,180"
   quit=.true. }
if (nz < 2 | ny < 2 | nx < 2) {
   write(6,*) ''
   write(6,*) "nx,ny,nz should be at least 2"
   quit=.true. }
nnx = nint((xmax-xmin)/dx) + 1
nny = nint((ymax-ymin)/dy) + 1
nnz = nint((zmax-zmin)/dz) + 1
if (nz != nnz | ny != nny | nx != nnx) {
   write(6,*) ''
   write(6,*) "nx,ny,nz not consistent with min,max values for x,y,z"
   write(6,*) "and with dx,dy,dz"
   quit=.true. }
if (nsq > mxsq) {
   write(6,*) ''
   write(6,*) 'nx*ny*nz too large, decrease nx,ny,nz'
   write(6,*) 'or increase mxsq (NOT recommended because of limited memory)'
   quit=.true. }

if (quit) { write(6,*) 'stop: change model.cube'; stop}

# average knot distance
ddd = (dx+dy+dz)/3.
dmn = min(dx,dy,dz)
dmx = max(dx,dy,dz)
if (dmx > 2.*dmn) {
   write(6,*) 'WARNING: knot-spacing varies too much in different'
   write(6,*) 'direction. Smoothing will possibly not work well.'
   write(6,*) 'Reminder: Earth is spherical and grid is cartesian'
}

# one third of knot distance is path step
avdd = ddd/3.
# go from km to radians
avdd = avdd/radius

# temporarily from radians to degrees
avddtmp = avdd/p
distmax = nrhor*avddtmp
write(6,*) 'Note: your maximum epicentral distance should not'
write(6,*) 'exceed ',distmax, ' degrees.'
write(6,*) ''
write(6,*) "avdd=",avddtmp," degr"

# now ddd (average knot-spacing) is in km and 
# avdd (path step size) in radians.

return
end
