subroutine convmod(nr,r,nr0,r0,vp,vs,rho,qshear,gtilde,maxtyp,npar,alpha,beta,density,quality)
include defines

dimension r(mxnds),r0(mxnds),rr(mxnds),rd(mxnds)
dimension vp(mxnds),vs(mxnds),rho(mxnds),qshear(mxnds)
dimension alpha(mxnds),beta(mxnds),density(mxnds),quality(mxnds)
dimension gtilde(mxnds,nrfpr,maxp),gt(mxnds,nrfpr,maxp)

# throw away unused background model layers
i0=1
j=1
if (r(1) < r0(1)) {
   rr(j) = r0(1)
   alpha(j) = vp(1)
   beta(j) = vs(1)
   density(j) = rho(1)
   quality(j) = qshear(1)
} else {
   rr(j) = r(1)
   do while (r(1) >= r0(i0)) {
      i0=i0+1 }
   alpha(j) = finterpol(r(1),r0(i0-1),r0(i0),vp(i0-1),vp(i0))
   beta(j) = finterpol(r(1),r0(i0-1),r0(i0),vs(i0-1),vs(i0))
   density(j) = finterpol(r(1),r0(i0-1),r0(i0),rho(i0-1),rho(i0))
   quality(j) = finterpol(r(1),r0(i0-1),r0(i0),qshear(i0-1),qshear(i0))
}
do while (r(nr) > r0(i0) & i0 <= nr0) {
   j=j+1
   rr(j) = r0(i0)
   alpha(j) = vp(i0)
   beta(j) = vs(i0)
   density(j) = rho(i0)
   quality(j) = qshear(i0) 
   i0=i0+1 }
if (i0 < (nr0 + 1)) {
   nrr = j + 1
   rr(nrr) = r(nr)
   alpha(nrr) = finterpol(r(nr),r0(i0-1),r0(i0),vp(i0-1),vp(i0))
   beta(nrr) = finterpol(r(nr),r0(i0-1),r0(i0),vs(i0-1),vs(i0))
   density(nrr) = finterpol(r(nr),r0(i0-1),r0(i0),rho(i0-1),rho(i0))
   quality(nrr) = finterpol(r(nr),r0(i0-1),r0(i0),qshear(i0-1),qshear(i0))
} else {
   nrr = j
}

# find discontinuities in path model:
id=0
do i=1,nr-1 {
   if (r(i) == r(i+1)) {
      id=id+1
      rd(id)=r(i) }
}
nd=id

# then add the extra ones to background model:
j=1
i=1
do while (i < nrr & j <= nd) {
   if (rr(i) == rd(j)) {
#      print*, 'already there',rr(i-1),rr(i),rr(i+1),rd(j)
      if (rr(i+1) != rd(j)) {
#	 print*,' but is not a disconti',rr(i-1),rr(i),rr(i+1),rd(j)
         i=i+2
         nrr=nrr+1
         do l=nrr,i,-1{
            rr(l) = rr(l-1)
            alpha(l) = alpha(l-1)
            beta(l) = beta(l-1)
            density(l) = density(l-1)
            quality(l) = quality(l-1) }
         rr(i-1) = rd(j)
         alpha(i-1) = alpha(i-2)
         beta(i-1) = beta(i-2)
         density(i-1) = density(i-2)
         quality(i-1) = quality(i-2)
      } 
      j=j+1 
   } else if (rr(i) > rd(j) & rr(i-1) < rd(j)) {
#      print*, 'inserting', rr(i-1),rr(i),rr(i+1),rd(j)
      i=i+2
      nrr=nrr+2
      do l=nrr,i,-1 {
	 rr(l) = rr(l-2)
         alpha(l) = alpha(l-2)
         beta(l) = beta(l-2)
         density(l) = density(l-2)
         quality(l) = quality(l-2) }
      rr(i-2) = rd(j)
      rr(i-1) = rr(i-2)
      alpha(i-2) = finterpol(rd(j),rr(i-3),rr(i),alpha(i-3),alpha(i))
      alpha(i-1) = alpha(i-2)
      beta(i-2) = finterpol(rd(j),rr(i-3),rr(i),beta(i-3),beta(i))
      beta(i-1) = beta(i-2)
      density(i-2) = finterpol(rd(j),rr(i-3),rr(i),density(i-3),density(i))
      density(i-1) = density(i-2)
      quality(i-2) = finterpol(rd(j),rr(i-3),rr(i),quality(i-3),quality(i))
      quality(i-1) = quality(i-2)
      j=j+1 
   } else {
      i=i+1
   }
}

# and find gtilde at points rr.
j=1
do i=1,nrr {
   do while (r(j) < rr(i)) {
      j=j+1 }
   if (r(j) == rr(i)) {
      do ip=1,npar {
      do im=1,maxtyp {
         gt(i,im,ip)=gtilde(j,im,ip) }}
      j=j+1 }
   else {
      do ip=1,npar {
      do im=1,maxtyp {
         gt(i,im,ip)=finterpol(rr(i),r(j-1),r(j),gtilde(j-1,im,ip),gtilde(j,im,ip)) }}}
}

# overwrite r and gtilde:
nr = nrr
do i=1,nr {
   r(i) = rr(i) 
   do ip=1,npar {
   do im=1,maxtyp {
      gtilde(i,im,ip) = gt(i,im,ip) }}
#   write(6,*) r(i)/1000,beta(i)/1000
#   write(6,*) ((gtilde(i,im,ip),ip=1,npar),im=1,maxtyp)
}

return
end
