subroutine getc(xp,yp,zp,rp,tp,fp,np,i,f,out)
include defines
include sdefines
dimension i(nonzsm),f(nonzsm)
dimension i8(nlin),f8(nlin)
dimension wc(kmax)
logical out
common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,xmin,xmax,dz,dy,dx
common/smooth/st,step,ksteps,mazi,w0,wc

# xyz grid counts from top layer, node 1 is at xmin,ymax and
# node nx is at xmax,ymax. node nx+1 is at xmin,ymax-1, etc. till
# node nx*ny. Next node is at z-1, xmin,ymax, etc.

np = 0
do l = 1,nonzsm { i(l) = 0; f(l) = 0. }

r0 = rp
t0 = tp
f0 = fp
x0 = xp
y0 = yp
z0 = zp

# check if x,y,z, is inside square grid:
# if not, return zero.
out = .false.
if (x0 < xmin | x0 > xmax | y0 < ymin | y0 > ymax | z0 < zmin | z0 > zmax) {
   out = .true. 
   return
}

call trilin(x0,y0,z0,n8,i8,f8)
do l=1,n8 {
   call addif(i8(l),f8(l),w0,np,i,f)
}

na = 0
dcst = 0.
az = 0.
do k = 1,ksteps {
   na = na + mazi
   daz = 2.*pi/na
   az = az + 0.5*daz
   dcst = dcst + step
   wk = wc(k)
   do ia = 1,na {
      az = az + daz
      call fiteta(f1,t1,f0,t0,az,dcst)
      call rtfxyz(0,t1,f1,r0,x1,y1,z1)
      call trilin(x1,y1,z1,n8,i8,f8)
      do l=1,n8 {
         call addif(i8(l),f8(l),wk,np,i,f)
      }
   }
}

return
end

subroutine trilin(xq,yq,zq,n8,i8,f8)
dimension i8(nlin),f8(nlin)
common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,xmin,xmax,dz,dy,dx

if (xq < xmin | xq > xmax | yq < ymin | yq > ymax | zq < zmin | zq > zmax) {
   n8 = 0
   return
} else {
   n8 = nlin
}

xdist = (xq - xmin)/dx
ydist = (ymax - yq)/dy
zdist = (zmax - zq)/dz

# coordinates of upper left back corner:
ixmn = int(xdist) + 1
ixmx = ixmn + 1
if (ixmn == nx) { ixmx = ixmn; ixmn = ixmx - 1 } 
iymn = int(ydist) + 1
iymx = iymn + 1
if (iymn == ny) { iymx = iymn; iymn = iymx - 1 }
izmn = int(zdist) + 1
izmx = izmn + 1
if (izmn == nz) { izmx = izmn; izmn = izmx - 1 }

lub = (izmn-1)*nxy + (iymn-1)*nx + ixmn 
i8(1) = lub
i8(2) = lub + 1
i8(3) = lub + nx
i8(4) = i8(3) + 1
i8(5) = lub + nxy
i8(6) = i8(5) + 1
i8(7) = i8(5) + nx
i8(8) = i8(7) + 1

# relative distance of point to 3 sides of cell:
x = xdist - (ixmn-1)
y = (iymx-1) - ydist
z = (izmx-1) - zdist

xy = x*y
xz = x*z
yz = y*z
xyz = xy*z

f8(1) = yz - xyz
f8(2) = xyz
f8(3) = z - yz - xz + xyz
f8(4) = xz - xyz
f8(5) = y - xy - yz + xyz
f8(6) = xy - xyz
f8(7) = 1 - x - y - z + xy + yz + xz - xyz
f8(8) = x - xy - xz + xyz

# 1 cube:
#
#        1________2 
#        /       /|
#      3/______4/ |
#       | |_____|_|6 
#       |/5     |/ 
#      7/_______/8 
#
#
# the index of a node:  i = (iz-1)*nx*ny + (iy-1)*nx + ix

return
end

subroutine wrers(xp,yp,zp,x,y,z)
   write(6,*) "DANGER: path is not completely in grid:"
   write(6,*) "x was ",xp," y was ",yp," z was ",zp
   write(6,*) "x is ",x," y is ",y," z is ",z
   write(6,*) "outward structure set to zero."
return
end

subroutine addif(iin,fin,wt,n,iarr,farr)
include sdefines
dimension iarr(nonzsm), farr(nonzsm)

jl = 0
ju = n + 1
do while ((ju-jl) > 1) {
   jm = (ju+jl)/2
   if (iin > iarr(jm)) jl = jm
   else ju = jm
}
# this gives jl and ju so that iarr(jl) < iin <= iarr(ju)

if (iin == iarr(ju)) {
   farr(ju) = farr(ju) + wt*fin
} else {
   n = n + 1
   do j = n,ju+1,-1 {
      iarr(j) = iarr(j-1)
      farr(j) = farr(j-1)
   }
   iarr(ju) = iin
   farr(ju) = wt*fin
}

return
end
