subroutine getclin(xp,yp,zp,np,i,f,out)
include defines
include sdefines
dimension i(nlin),f(nlin)
logical out
common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,xmin,xmax,dz,dy,dx

# xyz grid counts from top layer, node 1 is at xmin,ymax and
# node nx is at xmax,ymax. node nx+1 is at xmin,ymax-1, etc. till
# node nx*ny. Next node is at z-1, xmin,ymax, etc.

# check if x,y,z, is inside square grid:
x0 = xp
y0 = yp
z0 = zp
out = .false.
if (x0 < xmin | x0 > xmax |y0 < ymin | y0 > ymax | z0 < zmin | z0 > zmax) {
   out = .true. 
   np = 0
   return
}

np = 8

# ix: 1,4,5,8
# iy: 3,4,7,8
# iz: 5,6,7,8
#
#						    
#       8________7 
#       /       /| 
#     5/______6/ |           
#      | |_____|_|3
#      |/4     |/
#     1/_______/2
#
           
# the index of a node:  i = (iz-1)*nx*ny + (iy-1)*nx + ix
iz = int((zmax-z0)/dz) + 1
iy = int((ymax-y0)/dy) + 1
ix = int((x0-xmin)/dx) + 1
if (iz == nz) { iz = iz-1 }
if (iy == ny) { iy = iy-1 }
if (ix == nx) { ix = ix-1 }
i(1) = iz*nxy + iy*nx + ix
i(2) = i(1) + 1 
i(3) = i(2) - nx
i(4) = i(3) - 1
i(5) = i(1) - nxy
i(6) = i(5) + 1
i(7) = i(6) - nx
i(8) = i(7) - 1

# the relative position inside cube:
# distance from point to left node:
x = x0 - xmin - (ix-1)*dx  
# distance from point to closest/bottom node
y = y0 - ymin - (ny-iy-1)*dy
# distance from point to bottom node
z = z0 - zmin - (nz-iz-1)*dz 

# trilinear interpolation factors:
x = x/dx
y = y/dy
z = z/dz
xy = x*y
xz = x*z
yz = y*z
xyz = x*y*z
f(1) = 1 - x - y - z + xy + yz + xz - xyz
f(2) = x - xy - xz + xyz
f(3) = xy - xyz
f(4) = y - xy - yz + xyz
f(5) = z - yz - xz + xyz
f(6) = xz - xyz
f(7) = xyz
f(8) = yz - xyz

return
end
