subroutine gettlin(out,col,dmx,ela,elo,ntr,tt,pp,nti,i,f)
include workdefs
include sdefines
define nofclosev 8
define epsilon 0.0001
dimension tt(mxtr), pp(mxtr)
dimension i(ntri), f(ntri) 
dimension dmin(nofclosev), i7(nofclosev)
dimension ka(3000)
logical nextnode, out

nti = ntri
ddmn = epsilon*dmx

do l=1,nofclosev { dmin(l) = 2*pi; i7(l) = 0 }

range = 0.5*pi - ela
if (range > col | out) {
   out = .true.
   nti = 0
   return
}

de = 2.*dmx
range = 0.5*pi - de
tmin = ela - de
cela = cos(ela)

ik = 0
if (ela > range) {
   nrmx = 1
   do ir = 1,nint(2*de/dmx) {
      nrmx = nrmx + ir*5
   }  
   do k = 1,nrmx {
      ka(k) = k
   } 
   nk = nrmx
} else {
   do k = 1,ntr {
      ttabs = abs (tt(k) - ela)
      if (ttabs <= de) {
         ppelo = pp(k) - elo
         ppabs = min(abs(ppelo),abs(ppelo+2.*pi),abs(ppelo-2.*pi))
	 ppabs = cela*ppabs
         if (ppabs <= de) {
            ik = ik + 1
            ka(ik) = k
         }
      }
   }
   nk = ik
}
if (nk == 0) { 
   write(6,*) 'error: nk=0'
   stop
}

# find a number of closest vertices:
edmx = 1.06*dmx
nl = 0
do ik = 1,nk {
   call deltas(delta,tt(ka(ik)),pp(ka(ik)),ela,elo)
   if (delta <= edmx) {
      nl = nl+1
      if (nl > nofclosev) {
	 write(6,*) 'error: nl >',nofclosev,' for ela,elo = ',180.*ela/pi,180.*elo/pi
      } else {
         dmin(nl) = delta      
         i7(nl) = ka(ik)
      }
   } 
}
if (nl < 1) {
   write(6,*) 'error: nl<=0 for ela,elo = ',180.*ela/pi,180.*elo/pi
   nti = 0
   return
}
if (nl < 3) {
   write(6,*) 'error: nl<3 for ela,elo = ',180.*ela/pi,180.*elo/pi
   nti = 0
   return
}

# now sort the set of closest vertices:
do l=2,nl {
   do m=1,l-1 {
      if (dmin(l)<dmin(m)) {
         dmintmp = dmin(l)
         i7tmp = i7(l)
         do j=l,m+1,-1 {
            dmin(j) = dmin(j-1)
            i7(j) = i7(j-1) } 
         dmin(m) = dmintmp
         i7(m) = i7tmp 
}}}

# assume first vertex is right because it is closest,
# for the other two we can't be sure, try a next pair.

nextnode=.false.
l1=1; l2=2; l3=3
call trids(ds,dd,tt(i7(l2)),pp(i7(l2)),tt(i7(l3)),pp(i7(l3)),ela,elo,tt(i7(l1)),pp(i7(l1)))
if (dd <= ddmn) {
   nextnode=.true.
} else {
   factor = ds/dd
   if (factor > 1.) nextnode=.true.
}
do while (nextnode & l2 < nl-1) {
   if (l3 < nl) {l3=l3+1} else {l2=l2+1; l3=l2+1}
   call deltas(delta,tt(i7(l2)),pp(i7(l2)),tt(i7(l3)),pp(i7(l3)))
   if (delta <= dmx) {
      call trids(ds,dd,tt(i7(l2)),pp(i7(l2)),tt(i7(l3)),pp(i7(l3)),ela,elo,tt(i7(l1)),pp(i7(l1)))
      if (dd > ddmn) { 
	 factor = ds/dd 
         if (factor <= 1.) nextnode=.false.
      }
   }
}
i(1) = i7(l1)
f(1) = factor
fsum = factor

call trids(ds,dd,tt(i7(l1)),pp(i7(l1)),tt(i7(l3)),pp(i7(l3)),ela,elo,tt(i7(l2)),pp(i7(l2)))
if (dd <= ddmn) {
   write(6,*) 'error: dd=0! at second factor, for:',180.*ela/pi,180.*elo/pi
   write(6,*) 'point not included'
   nti = 0
   return
}
factor = ds/dd
if (factor > 1.) { 
   write(6,*) 'error, f>1 at second factor, for:',180.*ela/pi,180.*elo/pi
   write(6,*) 'point NOT included'
   nti = 0
   return
}
i(2) = i7(l2)
f(2) = factor
fsum = fsum + factor
call trids(ds,dd,tt(i7(l1)),pp(i7(l1)),tt(i7(l2)),pp(i7(l2)),ela,elo,tt(i7(l3)),pp(i7(l3)))
if (dd <= ddmn) {
   write(6,*) 'error: dd=0! at third factor, for:',180.*ela/pi,180.*elo/pi
   write(6,*) 'point not included'
   nti = 0
   return
}
factor = ds/dd
if (factor > 1.) { 
   write(6,*) 'error, f>1 at third factor, for:',180.*ela/pi,180.*elo/pi 
   write(6,*) 'point NOT included'
   nti = 0
   return
}
i(3) = i7(l3)
f(3) = factor
fsum = fsum + factor

f(1) = f(1)/fsum
f(2) = f(2)/fsum
f(3) = f(3)/fsum

return
end
