program hsmcomb
# builds matrix from newton5 constraints
# c 1994 Suzan vd Lee 
include defines
include sdefines
include worklims
character*72 bgmodel,constraints
character*50 matrix,rhs
character*56 sofm
character*4 runnr
dimension tarray(2)
dimension r0(mxnds),vp(mxnds),vs(mxnds),rho(mxnds),qshear(mxnds)
dimension alpha(mxnds),beta(mxnds),density(mxnds),quality(mxnds)
dimension r(mxnds)
dimension jflag(nrfpr),jy(nrfpr),jn(nrfpr)
dimension apu(nrfpr)
dimension qpar(maxp),stdev(maxp)
dimension gtilde(mxnds,nrfpr,maxp),gtdr(mxnds,nrfpr,maxp)
dimension c(nrhor)
dimension am(maxp,nrpgr)
dimension iq(nonzsm),pq(nonzsm)
dimension it(nonzsm),pt(nonzsm)
dimension iarr(nonzr),marr(nonzr)
dimension cvalue(maxp,nonzr)
dimension tt(mxtr),pp(mxtr)
dimension wc(kmax)
dimension colsum(nminv)
dimension ncount(nbin,nrfpr)
dimension rf(maxic)
logical skip,endoffile,out,slow,rowf
equivalence (gtilde,gtdr)
common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,xmin,xmax,dz,dy,dx
common/smooth/st,step,ksteps,mazi,w0,wc

write(6,*) 'program hsmcomb:'
#before start check consistency of dimensions:
call checkdims()
# IO setup:
10 format(a,$ )
skip=.false.

# read background model (from modes file, as in param5):
write(6,10) 'give background model modes file name: '
read(5,'(a)') bgmodel
write(6,*) bgmodel
open(2,file=bgmodel,status='old',form='unformatted',err=100)
rewind 2
read(2,err=101) radiusm,in0,nr0,nfreq,nbran,df,cmax
do i=1,nr0 {
   read(2,err=102) r0(i),vp(i),vs(i),rho(i),qshear(i) }
close(2)
# verify some background assumptions:
call verass(nr0,r0,skip)
if (skip) stop 
# find background moho depth:
call fzmoho(nr0,r0,vp,zmoho)
rmoho = radius - zmoho/1000.

# only invert waveform fitting results for certain parameters:
call setpar(njy,jy,apu,njn,jn,jmoho,apu5)

# define grids,  setgrid fills common grid, settria fills
# lat and lon of triangle vertices. 
call setgrid(ddd,avdd,distmax)
if (jmoho == 1) {
   call settria(ddd,dmx,col,rmoho,ntr,tt,pp)
}
stepk = min(dx,dy,dz)
step = stepk/radius
write(6,*) 'Give transverse smoothing length in km:'
read(5,*) stk
write(6,*) 'Transverse smoothing over',stk,' km'
st = stk/radius
call setsmooth(stk,st,step,ksteps,mazi,w0,wc)

ncol = njy*nsq + jmoho*ntr
if (ncol > nminv) {
   write(6,*) 'ERROR: increase nminv in worklims'
   write(6,*) 'nminv = ',nminv,' ncol = ',ncol
   stop
}

inquire(file='vsbg3d',exist=slow)
if (slow) {
   write(6,*) '3D background S-velocities exist, S-slowness inversion performed'
   j=1
   do while (jy(j) != 2) {
      j = j+1
   }
   if (j > njy) {
      write(6,*) 'No S-velocities in this inversion!' 
      write(6,*) 'No S-slowness inversion performed.'
      slow = .false.
   }
   indexs1 = (j-1)*nsq + 1
   indexs2 = indexs1 - 1 + nsq
#   stack limit problems, can't read vsbg3d, have to recompute further down
#   open(8,file='vsbg3d',status='old')
#   rewind 8
#   read(8,*) ncolv
#   read(8,*) (vsbg3d(j),j=1,ncolv)
#   close(8)
#   if (jmoho == 1) {
#      do j = ncolv+1, ncolv+ntr {
#	 vsbg3d(j) = -1.
#      }
#   }
}

# initialize:
nonz = nonzr - 1
ic=0
ifs=0
rmn=7000000.
rmx=0.
flamn=0.5*pi
flomn=2.*pi
flamx=-0.5*pi
flomx=-2.*pi
stxmin = xmax
stxmax = xmin
stymin = ymax
stymax = ymin
stzmin = zmax
stzmax = zmin
deltav = 0.
deltamn = 2.*pi
deltamx = 0.
#rmxdst = mxdst*p
rmxdst = distmax*p
nmmx = 0
constraints='O'
# avdd in radians from checkmodel (=(dx+dy+dz)/9)
c(1)=0.5
npg = nrhor 
do ipg=2,npg-1 {
   c(ipg)=1.}
nztot = 0
cvalmx = 0
cvalmn = 1e6
cvalav = 0
cvalaa = 0
cputot = 0.
do j = 1,ncol {
   colsum(j) = 0.
}
gtmax = -2.
do while (gtmax < 0. | gtmax > 1.) {
   write(6,10) 'Give cut-off value for gtilde in matrix row (e.g. 5e-8): '
   read(5,*) gtmax
}
write(6,*) gtmax

write(6,10) 'give name of output matrix:'
read(5,'(a)') matrix
write(6,*) matrix
write(6,10) 'give name of right hand side vector q:'
read(5,'(a)') rhs
write(6,*) rhs

open(3,file=matrix,form='unformatted',status='new')
rewind 3
open(4,file=rhs,status='new')
rewind 4
write(6,*) 'give "end" to stop input of constraints files'
write(6,*) ''
write(6,10) 'give constraints file name: '
read(5,'(a)') constraints
write(6,*) constraints

# read file of row factors:
inquire(file='rowfactors',exist=rowf)
if (rowf) {
   write(6,*) 'file rowfactors exists, will scale rows!'
   open(10,file='rowfactors',status='old')
   rewind 10
   do i = 1, 3996 {
      read(10,*) rf(i)
   }
} else {
   do i = 1, maxic {
      rf(i) = 1.
   }
}

# loop over all constraints files/paths:
do while (constraints != 'end') {
   open(1,file=constraints,status='old',err=103)
   rewind 1; endoffile=.false. 
   do while (! endoffile) {
      # read constraints:
      write(6,*) 'reading new constraints'
      read(1,fmt='(i4,1x,a4)',err=104) iftype,runnr
      read(1,*) evla,evlo,stla,stlo
      read(1,*) maxtyp
      read(1,*,err=105) (jflag(j),j=1,maxtyp)
      read(1,*) nr
      read(1,fmt='(5f12.1)',err=106) (r(l),l=1,nr)
      read(1,*) npar
      do i=1,npar {
         read(1,*) qpar(i),stdev(i)
         do j=1,maxtyp {
            if (jflag(j)!=0) {
               read(1,*) jtmp  
	       if (jtmp != j) {
		  write(6,*) 'error: parameter type ',j,'!=',jtmp
	       } 
	       read(1,fmt='(5e14.7)') (gtilde(l,j,i),l=1,nr) 
	    }
 	 }
      }
      # verify some assumptions:
      call verass(nr,r,skip)
      # see if gtilde is significant:
      call checkgt(nr,r,maxtyp,npar,gtmax,gtilde,skip,jflag,stdev,qpar)
      # check for off-switches for not-included-variables:
      do j=1,njn {
         if (jflag(jn(j)) != 0) {
            write(6,*) jn(j),'-th parameter inconsistently included'
            skip =.true.
         }
      }   
      if (jmoho == 0 & jflag(5) == 1) {
         write(6,*) 'inconsistent inclusion of moho'
         skip = .true.
      } 
      # proceed in radians:
      evla = evla*p
      evlo = evlo*p
      stla = stla*p
      stlo = stlo*p
      call epdist(evla,evlo,stla,stlo,delta0,azimuth0)
#      if (delta0 > rmxdst) { write(6,*) "delta too large"; skip = .true. }
      if (delta0 > rmxdst) { 
#        the following is only ok if the event and virtual event are
#        both located OUTSIDE the grid!
	 write(6,*) 'QUASI-ERROR:'
	 write(6,*) 'old event location:',evla/p,evlo/p
	 difdelta = delta0 - rmxdst + 1.*p
	 call nextcoor(evla,evlo,difdelta,azimuth0,stla,stlo) 
	 write(6,*) 'epicentral distance too large, cheated by'
	 write(6,*) 'moving the event forward along the great circle'
	 write(6,*) 'over ',difdelta/p,' degrees'
	 write(6,*) 'new event location:',evla/p,evlo/p
      }

      if (! skip) {
         # convert to background model, nr,r,vp,vs,rho,qshear and gtilde modified.
         call convmod(nr,r,nr0,r0,vp,vs,rho,qshear,gtilde,maxtyp,npar,alpha,beta,density,quality)
         # subtract background model from qpar
	 if (constraints == "constraints.thomas") {
            call subtbkq(npar,jflag,nr,r,gtilde,alpha,beta,density,quality,zmoho,qpar)
	 } else {
            call subtbk(npar,jflag,nr,r,gtilde,alpha,beta,density,quality,zmoho,qpar)
	 }

         # some statistics:
         rmn = min(r(1),rmn)
         rmx = max(r(nr),rmx)
         flamn = min(flamn,evla,stla)
         flamx = max(flamx,evla,stla)
         flomn = min(flomn,evlo,stlo)
         flomx = max(flomx,evlo,stlo)
         # rotate coordinates, relative to cube grid-northpole.
         # teta is new latitude (!) and fi is new longitude.
         call rotate(0,evla,evlo,evteta,evfi)
         call rotate(0,stla,stlo,stteta,stfi)
         write(6,*) 'event: ',evla/p,evlo/p,' rotated: ',evteta/p,evfi/p
         write(6,*) 'station ',runnr,':',stla/p,stlo/p,' rotated: ',stteta/p,stfi/p
         call epdist(evteta,evfi,stteta,stfi,delta,azimuth)
	 write(6,*) "delta=",delta0/p,"  rotated delta=",delta/p
	 deltav = deltav + delta
	 deltamx = max(deltamx,delta)
	 deltamn = min(deltamn,delta)
         # start greatcircle:
         ela = evteta
         elo = evfi
         # then find values at il-grid-points in path-plane:
         c(npg)=1.
         npg = nint(delta/avdd) + 1
         ddelta = delta/float(npg)
         npg=npg+1
         c(npg)=0.5
         cpg = ddelta/delta
         # determine parameters for vertical integration, this changes 
         # r to a continuous array and overwrites gtilde with the 
         # parameters, renamed to gtdr to avoid confusion:
         call vertrapz(nr,r,maxtyp,npar,gtilde,njy,jy)
         nnrp = nr*npg
         # set matrices A and C to zero:
         do k = 1, npar {
            do idp = 1, njy*nnrp+jmoho*npg {
	       am(k,idp) = 0. }
            do im = 1,nonzr {
	       cvalue(k,im) = 0. }}
         # reset non-zero counter:
         nm = 0
         do im = 1,nonzr {
	    iarr(im) = 0
	    marr(im) = 0 }
         cpu1 = etime(tarray)
   
         # now start the real work:
         do ipg=1,npg {
            do l=1,nr {
               # find relation between path-grid and cube grid:
	       # get x,y,z (in km):
	       rkm = r(l)/1000.
	       call rtfxyz(0,ela,elo,rkm,x,y,z)
               stxmin = min(stxmin,x)
               stxmax = max(stxmax,x)
               stymin = min(stymin,y)
               stymax = max(stymax,y)
               stzmin = min(stzmin,z) 
               stzmax = max(stzmax,z) 
   	       # get corners of cube in which x,y,z:
	       call getc(x,y,z,rkm,ela,elo,nq,iq,pq,out)
               il = (l-1)*npg+ipg
               do j=1,njy {
               if (jflag(jy(j))==1) {
	          # find relation between constraints and path-grid:
                  # count path-grid from source to station, from top to bottom:
                  ilj = (j-1)*nnrp + il
	          # path integral with trapezium rule:
                  do k=1,npar {
#	             am(k,ilj) = apu(j)*cpg*c(ipg)*0.5*gtdr(l,jy(j),k) }
	             am(k,ilj) = cpg*c(ipg)*0.5*gtdr(l,jy(j),k) }
	          # cm = am*bm (relation between constraints and cube grid):
	          do iiq = 1,nq {
	             i = (j-1)*nsq + iq(iiq)
		     call table(i,m,nm,iarr,marr)
		     if (nm > nonz) stop 'increase nonzr'
                     do k=1,npar {
                        cvalue(k,m) = cvalue(k,m) + am(k,ilj)*pq(iiq) }
	          }
               }}
	    }
            # same (on triangular 2D grid) for moho, if requested:
            if (jmoho == 1 & jflag(5)==1) {
               call gett(out,col,ela,elo,ntr,tt,pp,nt,it,pt)
               j5 = 4*nnrp + ipg
                  do k=1,npar {
#                     am(k,j5) = apu5*cpg*c(ipg)*gtilde(1,5,k) }
                     am(k,j5) = cpg*c(ipg)*gtilde(1,5,k) }
                  do iit = 1,nt {
                     i = njy*nsq + it(iit)
                     call table(i,m,nm,iarr,marr)
                     if (nm > nonz) stop 'increase nonzr'
                     do k=1,npar {
                        cvalue(k,m) = cvalue(k,m) + am(k,j5)*pt(iit) }
                  } 
            }
	    if (ipg==npg) {
	        write(6,*) 'apprx. rotated station coordinates: ',ela/p,elo/p } 
	    else {
	        # steps along great circle, modifies ela, elo, azimuth:
	        call nextcoor(ela,elo,ddelta,azimuth,stteta,stfi) }
         }
   
         cpu2 = etime(tarray)
	 cpudf = cpu2 - cpu1
	 cputot = cputot + cpudf
         write(6,*) 'runtime for this path: ',cpudf,' s = ',cpudf/60.,' min'
         write(6,*) 'there are ',nm,' non-zeroes per row of C'
         # statistics:
         nmmx = max(nmmx,nm)
         nztot = nztot + npar*nm 
         do im = 1,nm {
            index = iarr(im)
	    if (slow & index >= indexs1 & index <= indexs2) {
	       vsbg = compvsbg(index)
	       vsbg2 = -1.*vsbg*vsbg
	    } else {
	       vsbg2 = 1.
	    }
            do k = 1,npar {
               cvalue(k,marr(im)) = rf(ic+k)*vsbg2*cvalue(k,marr(im))
               cval = cvalue(k,marr(im))
               cvalmx = max(cvalmx,cval)
               cvalmn = min(cvalmn,cval)
               cvalav = cvalav + cval
               cvalaa = cvalaa + abs(cval)
	       colsum(index) = colsum(index) + cval*cval
            }
         }
	 do k = 1,npar {
	    qpar(k) = rf(ic+k)*qpar(k)
	 }
         # count ic # of constraints and paths/files.
         ic=ic+npar
         ifs=ifs+1
         # write matrix and right hand side to files:
         write(3) ifs,npar,nm
         write(3) (iarr(im),im=1,nm)
         do k = 1,npar {
	    write(3) (cvalue(k,marr(im)),im=1,nm)
	    write(4,*) qpar(k)
         }
   
      } else {
         write(6,*) constraints,' skipped' 
         skip=.false. 
      }
      # same or new constraint file?: (ugly construction with goto, but don't 
      # know a better way to determine EOF in fortran)
      read(1,*,end = 90) idum
      backspace(1)
      goto 91
90    endoffile=.true.; close(1)
91    continue
   }
   write(6,*) ''
   write(6,10) 'give next constraints file name: '
   read(5,'(a)') constraints
   write(6,*) constraints
}

close(3)
close(4)
nic = ic
nif = ifs
write(6,*) ''
write(6,*) nic,' constraints from',nif,' paths'
write(6,*) 'max nr. of nonzeroes per row of C = ',nmmx
write(6,*) 'matrix has ',nic,' rows and ',ncol,' columns'
sofm = 'sizeof'//matrix
write(6,*) sofm
write(6,*) nic,ncol,nmmx,nif
open(3,file=sofm)
rewind 3
  write(3,*) nic,ncol,nmmx,nif
close(3)

colmin = 100000.
colnmn = colmin
colmax = -1.
colnav = 0.
ntouched = 0
do j = 1,ncol {
   cj = sqrt(colsum(j))
   if (cj > 0.) {
      ntouched = ntouched + 1
      colnmn = min(colnmn,cj)
      colnav = colnav + cj
   }
   colsum(j) = cj
   colmin = min(colmin,cj)
   colmax = max(colmax,cj)
}
colnav = colnav/ntouched
open(7,file='columnsums')
rewind 7
write(7,*) ncol
write(7,*) (colsum(j),j=1,ncol)
close(7)
write(6,*) 'UNscaled columnsums written to file columnsums'
write(6,*) 'columnsums-min and -max: ',colmin,colmax
write(6,*) 'columnsums-min > 0: ',colnmn
write(6,*) 'columnsums average (non-zero): ',colnav
write(6,*) ntouched, ' nodes of model.cube are "touched" by the data'
write(6,*) ''

do j = 1,nrfpr {
   do ibin=1,nbin {
      ncount(ibin,j) = 0
   } 
}
colmaxapu = 0.
do j = 1,njy {
   do icol = (j-1)*nsq + 1, j*nsq {
      colsum(icol) = apu(j)*colsum(icol)
      colmaxapu = max(colmaxapu,colsum(icol))
   }
}
if (jmoho == 1) {
   do icol = njy*nsq + 1, njy*nsq + ntr {
      colsum(icol) = apu5*colsum(icol)
      colmaxapu = max(colmaxapu,colsum(icol))
   }
}
crange = 1.0001*colmaxapu
dbin = crange/nbin
do j = 1,njy {
   do icol = (j-1)*nsq + 1, j*nsq {
      ibin = 1 + int(colsum(icol)/dbin)
      ncount(ibin,j) = ncount(ibin,j) + 1
   }
}
if (jmoho == 1) {
   j = njy + 1
   do icol = njy*nsq + 1, njy*nsq + ntr {
      ibin = 1 + int(colsum(icol)/dbin)
      ncount(ibin,j) = ncount(ibin,j) + 1
   }
}
write(6,*) 'columnsums histogram incl. ext. scaling with',(apu(j),j=1,njy),apu5
write(6,*) 'Use this to choose epsilon for scalcol'
do j = 1, njy + jmoho {
   if (j <= njy) {
      jtype = jy(j)
   } else {
      jtype = 5
   }
   write(6,*) j, jtype,':'
   do ibin = 1,nbin {
      write(6,*) (ibin-1)*dbin, ibin*dbin, ncount(ibin,j)
   }
}
write(6,*) ''
scepsilon = 0.2
open(9,file='columnfactors0')
rewind 9
write(9,*) ncol, nsq, njy, (apu(j),j=1,njy), jmoho*ntr, apu5, colmaxapu, scepsilon
close(9)
write(6,*) 'file columnfactors0 (apu) written. Edit apu or scepsilon in this'
write(6,*) 'file if different ext. or int. column scaling is desired!'

write(6,*) ''
cvalav = cvalav/nztot 
cvalaa = cvalaa/nztot 
write(6,*) 'min non-zero matrix-element = ',cvalmn
write(6,*) 'average nonz matrix-element = ',cvalav
write(6,*) 'max non-zero matrix-element = ',cvalmx 
write(6,*) 'average absolute nonz matrix-element = ',cvalaa
write(6,*) ''
write(6,*) 'area of paths has:'
write(6,*) rmn/1000.,rmx/1000.,' min and max radius'
write(6,*) flamn/p,flamx/p,' min and max latitude'
write(6,*) flomn/p,flomx/p,' min and max longitude'
write(6,*) ''
write(6,*) stzmin,stzmax,' min and max z'
write(6,*) stymin,stymax,' min and max y'
write(6,*) stxmin,stxmax,' min and max x'
if (stxmin < xmin | stxmax > xmax | stymin < ymin | stymax > ymax | 
    stzmin < zmin | stzmax > zmax) {
   write(6,*) 'ERROR?: path-area not completely covered by model'
}
write(6,*) ''
epdmx = deltamx/p
write(6,*) 'min ep dist is: ',deltamn/p
write(6,*) 'average ep dist is: ',deltav/(nif*p)
write(6,*) 'max ep dist is: ',epdmx
if (epdmx > distmax) {
   write(6,*) 'ERROR: maximum epicentral distance too large'
   write(6,*) 'Array bounds have probably been exceeded without notice.'
   write(6,*) 'Remedy: increase the average of dx,dy,dz in "model.cube"'
   write(6,*) 'or: increase nrhor and nrpgr in "defines" and recompile'
   stop
}
write(6,*) ''
write(6,*) 'total cpu time for paths: ',cputot/60,' min'
write(6,*) ''
write(6,*) 'hsmcomb finished'
goto 107

100 write(6,*) 'error opening ', bgmodel ; stop
101 write(6,*) 'error reading 1st line of ', bgmodel ; stop
102 write(6,*) 'error reading model from ', bgmodel ; stop
103 write(6,*) 'error opening ', constraints ; stop
104 write(6,*) 'error reading 1st line from ', constraints ; stop
105 write(6,*) 'error reading jflag from ', constraints ; stop
106 write(6,*) 'error reading model from ', constraints ; stop
107 end
