program makeanieu
include defines
define nlin        8
define ntri        3
define kmax       10    # max. nr. of steps in smoothing length.
define nonzsm    30000    # nr. of non-zeroes for smoothing matrix. (>=1!)
                        # depends on kmax.
include worklims
#
# makes synthetic model for S-velocity, using data-structure.
character*7 fname
dimension solution(nminv)
dimension jy(nrfpr),jn(nrfpr),apu(nrfpr)
dimension ia(nonzsm),fa(nonzsm)
dimension wc(10)
dimension xnode(nminv),ynode(nminv)
logical out
real mel,cla,clo,x1,x2,node_counter,deltaz,dist_hor
data itypeS/2/

common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,xmin,xmax,dz,dy,dx
common/smooth/st,step,ksteps,mazi,w0,wc

do i=1,nminv {
   solution(i) = 0.
}
 
call setgrid(ddd,avdd,distmax)
open(1,file='model.shell',status='old')
rewind(1)
read(1,*) ntr,nt,imx,dmxd,cold,rmoho
write(6,*) nsq,' nodes in 3D model'
close(1)
call setpar(njy,jy,apu,njn,jn,jmoho,apu5)
n=0
j=1
do while (jy(j) < itypeS) {
   n = n+1
   j = j+1
}
if (jy(j) != itypeS) {
   write(6,*) 'Sorry, your data do not include S-velocities,'
   write(6,*) 'I will not compute a synthetic S-velocity model.'
   stop
}
apus=apu(j)
ioff=n
noff = ioff*nsq
ncol = njy*nsq + jmoho*ntr
write(6,*) 'offset=',noff,' apu-S=',apus,' ncol=',ncol

# r_up and r_down determined by 1) delay time between fast and 
# slow SKS, 2) assumption for reasonable level of anisotropy
# (e.g. olivine preferred orientation), and 3) assumption on
# depth range of anisotropy.
write(6,*) "Give depth (in km) to top of anisotropic layer:"
read(5,*) rup
write(6,*) "Give depth (in km) to bottom of anisotropic layer:"
read(5,*) rdown
rup = radius - rup
rdown = radius - rdown
# dbeta  (in m/s) determined from 1) delay time between fast 
# and slow SKS, 2) thickness of anisotropic layer, 3) deviation 
# of wave propagation azimuth from fast SKS axis, and 4) length 
# of wave path through anisotropic region.
write(6,*) "Give equivalent S-velocity perturbation (in m/s):"
read(5,*) dbeta

# realistic model: 
index = noff
z = zmax + dz
do iz = 1, nz {
   z = z - dz
   y = ymax + dy
   do iy = 1, ny {
      y = y - dy
      x = xmin - dx
      do ix = 1, nx {
         x = x + dx
         index = index+1
         call rtfxyz(1,t,f,r,x,y,z)
         call rotate(1,t,f,tt,ft)
         t = tt/p
         f = ft/p
         if (r <= rup & r >= rdown) {
            solution(index) = dbeta
         }
      }
   }
} 

smin = 0
smax = 0
do i=1,ncol {
   smax = max(solution(i),smax)
   smin = min(solution(i),smin)
}
write(6,*) 'min,max solution:',smin,smax
fname = "syn.ani"
open(1,file=fname,status='new')
rewind 1
write(1,*) ncol
write(1,*) (solution(i),i=1,ncol)
close(1)

end


