program makeref
include defines
define nlin        8
define ntri        3
define kmax       10    # max. nr. of steps in smoothing length.
define nonzsm    30000    # nr. of non-zeroes for smoothing matrix. (>=1!)
                        # depends on kmax.
include worklims
define nspik 2
define ndip 1
#
define nspk 47
define ndp 2
# makes synthetic model for S-velocity, using data-structure.
character*7 fname
dimension solution(nminv)
dimension jy(nrfpr),jn(nrfpr),apu(nrfpr)
dimension ia(nonzsm),fa(nonzsm)
dimension spkdp(ndp),spkla(nspk),spklo(nspk)
dimension spikdp(ndip),spikla(nspik),spiklo(nspik)
dimension wc(10)
logical out
real mel,cla,clo,x1,x2
data itypeS/2/
data spikdp/200/
data spikla/-21,-5/
data spiklo/-47,-63/
#
data spkdp/100.,300./
data spkla /-1.,-1.,-1.,-1.,-1.,-1.,-1.,-1.,-7.,-7.,-7.,-7.,-7.,-7.,-7.,-7.,-13.,-13.,-13.,-13.,-13.,-13.,-13.,-13.,-19.,-19.,-19.,-19.,-19.,-19.,-19.,-19.,-25.,-25.,-25.,-25.,-25.,-25.,-25.,-25.,-31.,-31.,-31.,-31.,-31.,-31.,-31./
data spklo /-84.,-78.,-72.,-66.,-60.,-54.,-48.,-42.,-84.,-78.,-72.,-66.,-60.,-54.,-48.,-42.,-84.,-78.,-72.,-66.,-60.,-54.,-48.,-42.,-84.,-78.,-72.,-66.,-60.,-54.,-48.,-42.,-84.,-78.,-72.,-66.,-60.,-54.,-48.,-42.,-78.,-72.,-66.,-60.,-54.,-48.,-42./
common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,xmin,xmax,dz,dy,dx
common/smooth/st,step,ksteps,mazi,w0,wc

do i=1,nminv {
   solution(i) = 0.
}
 
# rotate Mercator-evenly-spaced grid to diamond (over 45 degrees):
cla = 35.
clo = 2.5
mel = 0.70710678
do i=1,nspk {
   x1 = spkla(i) - cla
   x2 = spklo(i) - clo
   spkla(i) = cla + mel*x1 - mel*x2
   spklo(i) = clo + mel*x1 + mel*x2
}
print*, spkla(1),spklo(1)

call setgrid(ddd,avdd,distmax)
open(1,file='model.shell',status='old')
rewind(1)
read(1,*) ntr,nt,imx,dmxd,cold,rmoho
write(6,*) nsq,' nodes in 3D model'
close(1)
call setpar(njy,jy,apu,njn,jn,jmoho,apu5)
n=0
j=1
do while (jy(j) < itypeS) {
   n = n+1
   j = j+1
}
if (jy(j) != itypeS) {
   write(6,*) 'Sorry, your data do not include S-velocities,'
   write(6,*) 'I will not compute a synthetic S-velocity model.'
   stop
}
apus=apu(j)
ioff=n
noff = ioff*nsq
ncol = njy*nsq + jmoho*ntr
write(6,*) 'offset=',noff,' apu-S=',apus,' ncol=',ncol

# many spikes: (harmonic)
dsol = -300.
stk = 200.
st = stk/radius
step = 60./radius
call setfakesmooth(stk,st,step,ksteps,mazi,w0,wc)

do k=1,ndp {
   r = radius - spkdp(k)
   print*, "layer at",r, " dsol=",dsol
   do j=1,nspk {
      plat = p*spkla(j)
      plon = p*spklo(j)
      call rotate(0,plat,plon,tt,ft)
      call rtfxyz(0,tt,ft,r,x,y,z)
      call getc(x,y,z,r,tt,ft,np,ia,fa,out)
      if (out) print*, 'error, out is true'
      do i = 1,np {
         solution(ia(i)) = solution(ia(i)) + dsol
      }
      dsol = -1.*dsol
      if (j == 8) dsol = -1.*dsol
      if (j == 16) dsol = -1.*dsol
      if (j == 24) dsol = -1.*dsol
      if (j == 32) dsol = -1.*dsol
   }
}



smin = 0
smax = 0
do i=1,ncol {
   smax = max(solution(i),smax)
   smin = min(solution(i),smin)
}
write(6,*) 'min,max solution:',smin,smax
fname = "syn.p00"
open(1,file=fname,status='new')
rewind 1
write(1,*) ncol
write(1,*) (solution(i),i=1,ncol)
close(1)


kdp = 1
jspk = 0
dsol = -300.

###do kf = 1,2*nspk {
###
###do i=1,nminv {
###   solution(i) = 0.
###}
###
###stk = 200.
###st = stk/radius
###step = 60./radius
###call setfakesmooth(stk,st,step,ksteps,mazi,w0,wc)
###
###jspk = kf
###if (kf > nspk) {
###   kdp = 2
###   jspk = jspk - nspk
###}
###print*, kdp,jspk
###
###do k=kdp,kdp {
###   r = radius - spkdp(k)
###   print*, "layer at",r, " dsol=",dsol
###   do j=jspk,jspk {
###      plat = p*spkla(j)
###      plon = p*spklo(j)
###      call rotate(0,plat,plon,tt,ft)
###      call rtfxyz(0,tt,ft,r,x,y,z)
###      call getc(x,y,z,r,tt,ft,np,ia,fa,out)
###      if (out) print*, 'error, out is true'
###      do i = 1,np {
###         solution(ia(i)) = solution(ia(i)) + dsol
###      }
###      dsol = -1.*dsol
###      if (j == 8) dsol = -1.*dsol
###      if (j == 16) dsol = -1.*dsol
###      if (j == 24) dsol = -1.*dsol
###      if (j == 32) dsol = -1.*dsol
###   }
###}
###smin = 0
###smax = 0
###do i=1,ncol {
###   smax = max(solution(i),smax)
###   smin = min(solution(i),smin)
###}
###write(6,*) 'min,max solution:',smin,smax
###kfd = int(0.1*kf)
###kf1 = kf - 10.*kfd
###print*, kfd,kf1
###fname = "syn.p"//char(kfd+48)//char(kf1+48)
###print*, fname
###open(1,file=fname,status='new')
###rewind 1
###write(1,*) ncol
###write(1,*) (solution(i),i=1,ncol)
###close(1)
###}

end

subroutine slab(r,lat,lon,s,k)
dimension s(nminv)
real llon0,rlon0,lon0
real lat,lon

data rup /6371./
data rdown /5711./

data dbeta /+300./

if (r > rup | r < rdown) return
if (lat < -38 | lat > -5) return
lon0 = -74.0
if (lon < lon0 | lon > lon0 + 2.5 + 10.7) return

llon0 = lon0 + (rup-r)*10.7/660.
rlon0 = llon0 + 2.5

if (lon < llon0 | lon > rlon0) return

s(k) = dbeta
return
end

subroutine wedge(r,lat,lon,s,k)
dimension s(nminv)
real llon0,rlon0,lon0
real lat,lon

data rup /6306./
data rdown /6113./

data dbeta /-300./

if (r > rup | r < rdown) return
if (lat < -38 | lat > -5) return
lon0 = -74.0 + 2.5 + 1.
if (lon < lon0 | lon > lon0 + 4.) return

llon0 = lon0 + (rup-r)*4./257.
rlon0 = lon0 + 4.

if (lon < llon0 | lon > rlon0) return

s(k) = dbeta
return
end


SUBROUTINE SORT(N,RA,NA)
DIMENSION RA(N), NA(N)
L=N/2+1
IR=N
10 CONTINUE
IF (L.GT.1) {
   L=L-1
   RRA=RA(L)
   NNA=NA(L)
} else {
   RRA=RA(IR)
   NNA=NA(IR)
   RA(IR)=RA(1)
   NA(IR)=NA(1)
   IR=IR-1
   IF (IR.EQ.1) {
      RA(1)=RRA
      NA(1)=NNA
      RETURN
   }
}
I=L
J=L+L
20 IF (J.LE.IR) {
      IF (J.LT.IR) {
         IF (RA(J).GT.RA(J+1))J=J+1
      }  
      IF (RRA.GT.RA(J)) {
         RA(I)=RA(J)
         NA(I)=NA(J)
         I=J
         J=J+J
      } else {         
         J=IR+1
      }
      GO TO 20
  }
  RA(I)=RRA
  NA(I)=NNA
  GO TO 10
  END

subroutine setfakesmooth(stk,st,step,ksteps,mazi,w0,wc)
define pi          3.1415926535897932
define nlin        8
define ntri        3
define kmax       10    # max. nr. of steps in smoothing length.
define nonzsm    30000    # nr. of non-zeroes for smoothing matrix. (>=1!)
                        # depends on kmax.
dimension wc(kmax)

ksteps = int(st/step-0.0001)
if (ksteps <0 | ksteps > kmax) {
   write(6,*) 'No such smoothing'
   stop
}
write(6,*) 'ksteps = ',ksteps
mazi = 8
w0 = 1.
wsum = w0
do k = 1,ksteps {
#   wc(k) = 8.*(1. - k*step/st)
   wc(k) = 8.*cos(0.5*pi*k*step/st)
   wsum = wsum + k*wc(k)
}
w0 = w0/wsum
do k = 1,ksteps {
   wc(k) = wc(k)/(wsum*mazi)
}
write(6,*) stk,st,step,ksteps,mazi
write(6,*) w0,(wc(k),k=1,ksteps)

return
end

subroutine getc(xp,yp,zp,rp,tp,fp,np,i,f,out)
include defines
define nlin        8
define ntri        3
define kmax       10    # max. nr. of steps in smoothing length.
define nonzsm    30000    # nr. of non-zeroes for smoothing matrix. (>=1!)
dimension i(nonzsm),f(nonzsm)
dimension i8(nlin),f8(nlin)
dimension wc(kmax)
logical out
common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,xmin,xmax,dz,dy,dx
common/smooth/st,step,ksteps,mazi,w0,wc

# xyz grid counts from top layer, node 1 is at xmin,ymax and
# node nx is at xmax,ymax. node nx+1 is at xmin,ymax-1, etc. till
# node nx*ny. Next node is at z-1, xmin,ymax, etc.

np = 0
do l = 1,nonzsm { i(l) = 0; f(l) = 0. }

r0 = rp
t0 = tp
f0 = fp
x0 = xp
y0 = yp
z0 = zp

# check if x,y,z, is inside square grid:
# if not, return zero.
out = .false.
if (x0 < xmin | x0 > xmax | y0 < ymin | y0 > ymax | z0 < zmin | z0 > zmax) {
   out = .true. 
   return
}

#r0 = r0 + 60
r0 = r0 + 90
#do kdp = 1,3 {
do kdp = 1,4 {

call rtfxyz(0,t0,f0,r0,x0,y0,z0)
call trilin(x0,y0,z0,n8,i8,f8)
do l=1,n8 {
   call addif(i8(l),f8(l),w0,np,i,f)
}

na = 0
dcst = 0.
az = 0.
do k = 1,ksteps {
   na = na + mazi
   daz = 2.*pi/na 
   az = az + 0.5*daz
   dcst = dcst + step
   wk = wc(k)
   do ia = 1,na {
      az = az + daz
      call fiteta(f1,t1,f0,t0,az,dcst)
      call rtfxyz(0,t1,f1,r0,x1,y1,z1)
      call trilin(x1,y1,z1,n8,i8,f8)
      do l=1,n8 {
         call addif(i8(l),f8(l),wk,np,i,f)
      }
   }
}
r0 = r0 - 60.
}

return
end

subroutine trilin(xq,yq,zq,n8,i8,f8)
dimension i8(nlin),f8(nlin)
common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,xmin,xmax,dz,dy,dx

if (xq < xmin | xq > xmax | yq < ymin | yq > ymax | zq < zmin | zq > zmax) {
   n8 = 0
   return
} else {
   n8 = nlin
}

xdist = (xq - xmin)/dx
ydist = (ymax - yq)/dy
zdist = (zmax - zq)/dz

# coordinates of upper left back corner:
ixmn = int(xdist) + 1
ixmx = ixmn + 1
if (ixmn == nx) { ixmx = ixmn; ixmn = ixmx - 1 } 
iymn = int(ydist) + 1
iymx = iymn + 1
if (iymn == ny) { iymx = iymn; iymn = iymx - 1 }
izmn = int(zdist) + 1
izmx = izmn + 1
if (izmn == nz) { izmx = izmn; izmn = izmx - 1 }

lub = (izmn-1)*nxy + (iymn-1)*nx + ixmn 
i8(1) = lub
i8(2) = lub + 1
i8(3) = lub + nx
i8(4) = i8(3) + 1
i8(5) = lub + nxy
i8(6) = i8(5) + 1
i8(7) = i8(5) + nx
i8(8) = i8(7) + 1

# relative distance of point to 3 sides of cell:
x = xdist - (ixmn-1)
y = (iymx-1) - ydist
z = (izmx-1) - zdist

xy = x*y
xz = x*z
yz = y*z
xyz = xy*z

f8(1) = yz - xyz
f8(2) = xyz
f8(3) = z - yz - xz + xyz
f8(4) = xz - xyz
f8(5) = y - xy - yz + xyz
f8(6) = xy - xyz
f8(7) = 1 - x - y - z + xy + yz + xz - xyz
f8(8) = x - xy - xz + xyz

# 1 cube:
#
#        1________2 
#        /       /|
#      3/______4/ |
#       | |_____|_|6 
#       |/5     |/ 
#      7/_______/8 
#
#
# the index of a node:  i = (iz-1)*nx*ny + (iy-1)*nx + ix

return
end

subroutine addif(iin,fin,wt,n,iarr,farr)
define nonzsm    30000    # nr. of non-zeroes for smoothing matrix. (>=1!)
                        # depends on kmax.
dimension iarr(nonzsm), farr(nonzsm)

jl = 0
ju = n + 1
do while ((ju-jl) > 1) {
   jm = (ju+jl)/2
   if (iin > iarr(jm)) jl = jm
   else ju = jm
}
# this gives jl and ju so that iarr(jl) < iin <= iarr(ju)

if (iin == iarr(ju)) {
   farr(ju) = farr(ju) + wt*fin
} else {
   n = n + 1
   do j = n,ju+1,-1 {
      iarr(j) = iarr(j-1)
      farr(j) = farr(j-1)
   }
   iarr(ju) = iin
   farr(ju) = wt*fin
}

return
end
