program makeeuc
include defines
define nlin        8
define ntri        3
define kmax       10    # max. nr. of steps in smoothing length.
define nonzsm    30000    # nr. of non-zeroes for smoothing matrix. (>=1!)
                        # depends on kmax.
include worklims
define nspik 2
define ndip 1
#
define nspk 40
define ndp 1
# makes synthetic model for S-velocity, using data-structure.
character*7 fname
dimension solution(nminv)
dimension jy(nrfpr),jn(nrfpr),apu(nrfpr)
dimension ia(nonzsm),fa(nonzsm)
dimension spkdp(ndp),spkla(nspk),spklo(nspk)
dimension spikdp(ndip),spikla(nspik),spiklo(nspik)
dimension wc(kmax)
dimension xnode(nminv),ynode(nminv)
dimension it(nonzsm),if(nonzsm)
dimension tt(mxtr),pp(mxtr)
logical out
real mel,cla,clo,x1,x2,node_counter,deltaz,dist_hor
data itypeS/2/
data itypemoho/5/
data spikdp/200/
data spikla/-21,-5/
data spiklo/-47,-63/

common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,xmin,xmax,dz,dy,dx
common/smooth/st,step,ksteps,mazi,w0,wc

do i=1,nminv {
   solution(i) = 0.
}
 
call setgrid(ddd,avdd,distmax)
write(6,*) nsq,' nodes in 3D model'
open(1,file='model.shell',status='old')
rewind(1)
read(1,*) ntr,nt,imx,dmxd,cold,rmoho
read(1,*) (tt(i),i=1,ntr)
read(1,*) (pp(i),i=1,ntr)
close(1)
col = cold*p
call setpar(njy,jy,apu,njn,jn,jmoho,apu5)
n=0
j=1
do while (jy(j) < itypemoho) {
   n = n+1
   j = j+1
}
if (jy(j) != itypemoho) {
   write(6,*) 'Sorry, your data do not include Moho'
   write(6,*) 'I will not compute a synthetic model.'
   stop
}
apus=apu(j)
ioff=n
noff = ioff*nsq
print*, 'noff=',noff
ncol = njy*nsq + jmoho*ntr
write(6,*) 'offset=',noff,' apu-S=',apus,' ncol=',ncol

stk = 80.
st = stk/radius
step = 55./radius
call setfakesmooth(stk,st,step,ksteps,mazi,w0,wc)
out = .false.
# realistic model: 
open(2,file='crust.xyz',status='old')
rewind 2
29 read(2,*,end=34) on,at,oho
   at = at*p
   on = on*p
   call rotate(0,at,on,t,f)
   call gett(out,col,t,f,ntr,tt,pp,nl,it,ft)
   do l=1,nl {
      index = noff + it(l) 
      solution(index) = (oho - 30.)*1000.
   }
   goto 29
34 continue

smin = 0
smax = 0
do i=1,ncol {
   smax = max(solution(i),smax)
   smin = min(solution(i),smin)
}
write(6,*) 'min,max solution:',smin,smax
fname = "syn.moho"
open(1,file=fname,status='new')
rewind 1
write(1,*) ncol
write(1,*) (solution(i),i=1,ncol)
close(1)

kdp = 1
jspk = 0
dsol = -300.

end

subroutine slab1(r,lat,lon,s,k)
dimension s(nminv)
real llon0,rlon0,lon0
real lat,lon

data rup /6371./
data rdown /5711./

data dbeta /+300./

if (r > rup | r < rdown) return
if (lat < 34. | lat > 43.) return
lon0 = 0.44*(83.75-lat) 
if (lon < lon0 | lon > lon0 + 2.0 + 10.7) return

llon0 = lon0 + (rup-r)*10.7/660.
rlon0 = llon0 + 2.0

if (lon < llon0 | lon > rlon0) return

s(k) = dbeta
return
end

subroutine slab1neg(r,lat,lon,s,k)
dimension s(nminv)
real llon0,rlon0,lon0
real lat,lon

data rup /6371./
data rdown /5711./

data dbeta /-300./

if (r > rup | r < rdown) return
if (lat < 34. | lat > 43.) return
lon0 = 0.44*(83.75-lat) + 2.0 
if (lon < lon0 | lon > lon0 + 2.0 + 10.7) return

llon0 = lon0 + (rup-r)*10.7/660.
rlon0 = llon0 + 2.0

if (lon < llon0 | lon > rlon0) return

s(k) = dbeta
return
end

subroutine slab2(r,lat,lon,s,k)
dimension s(nminv)
real llon0,rlon0,lon0
real lat,lon

data rup /6371./
data rdown /5711./

data dbeta /+400./

if (r > rup | r < rdown) return
if (lat < 36. | lat > 40.) return
lon0 = 0.75*(lat-17)
if (lon > lon0 | lon < lon0 - 2.0 - 7.7) return

llon0 = lon0 - (rup-r)*7.7/660.
rlon0 = llon0 - 2.0

if (lon > llon0 | lon < rlon0) return

s(k) = dbeta
return
end

subroutine slab2neg(r,lat,lon,s,k)
dimension s(nminv)
real llon0,rlon0,lon0
real lat,lon

data rup /6371./
data rdown /5711./

data dbeta /-400./

if (r > rup | r < rdown) return
if (lat < 36. | lat > 40.) return
lon0 = 0.75*(lat-17) - 1.5
if (lon > lon0 | lon < lon0 - 1.5 - 7.7) return

llon0 = lon0 - (rup-r)*7.7/660.
rlon0 = llon0 - 2.0

if (lon > llon0 | lon < rlon0) return

s(k) = dbeta
return
end

subroutine slab3(r,lat,lon,s,k)
dimension s(nminv)
real llon0,rlon0,lon0
real lat,lon

data rup /6371./
data rdown /5711./

data dbeta /+400./

if (r > rup | r < rdown) return
if (lat < 40. | lat > 45.) return
lon0 = 1.25*(56.4-lat)
if (lon > lon0 | lon < lon0 - 2.0 - 10.7) return

llon0 = lon0 - (rup-r)*10.7/660.
rlon0 = llon0 - 2.0

if (lon > llon0 | lon < rlon0) return

s(k) = dbeta
return
end

subroutine slab3neg(r,lat,lon,s,k)
dimension s(nminv)
real llon0,rlon0,lon0
real lat,lon

data rup /6371./
data rdown /5711./

data dbeta /-400./

if (r > rup | r < rdown) return
if (lat < 40. | lat > 45.) return
lon0 = 1.25*(56.4-lat) - 2.0 - 1.5
if (lon > lon0 | lon < lon0 - 2.0 - 10.7) return

llon0 = lon0 - (rup-r)*10.7/660.
rlon0 = llon0 - 2.0

if (lon > llon0 | lon < rlon0) return

s(k) = dbeta
return
end

subroutine slab4(r,lat,lon,s,k)
dimension s(nminv)
real llon0,rlon0,lat0
real lat,lon

data rup /6171./
data rdown /5711./

data dbeta /+400./

if (r > rup | r < rdown) return
if (lon < -3. | lon > 3.) return
lat0 = 37.
if (lat < lat0 | lat > lat0 + 2.0 + 7.5) return

llat0 = lat0 + (rup-r)*7.5/460.
rlat0 = llat0 + 2.0

if (lat < llat0 | lat > rlat0) return

s(k) = dbeta
return
end

subroutine slab4neg(r,lat,lon,s,k)
dimension s(nminv)
real llon0,rlon0,lat0
real lat,lon

data rup /6171./
data rdown /5711./

data dbeta /-400./

if (r > rup | r < rdown) return
if (lon < -3. | lon > 3.) return
lat0 = 37. + 2.0                                                  
if (lat < lat0 | lat > lat0 + 2.0 + 7.5) return

llat0 = lat0 + (rup-r)*7.5/460.
rlat0 = llat0 + 2.0

if (lat < llat0 | lat > rlat0) return

s(k) = dbeta
return                                                      
end

subroutine wedge1(r,lat,lon,s,k)
dimension s(nminv)
real lat,lon,lon0

data rup /6306./
data rdown /6171./

data dbeta /-200./

if (r > rup | r < rdown) return
if (lat < 34 | lat > 43) return
lon0 = 0.44*(83.75-lat) + 2.0 + 2.0 + 2.0
if (lon < lon0 | lon > lon0 + 4.) return

llon0 = lon0 + (rup-r)*4./257.
rlon0 = lon0 + 4.

if (lon < llon0 | lon > rlon0) return

s(k) = dbeta
return
end

subroutine wedge2(r,lat,lon,s,k)
dimension s(nminv)
real lat,lon,lon0

data rup /6306./
data rdown /6163./

data dbeta /-250./

if (r > rup | r < rdown) return
if (lat < 36 | lat > 40) return
lon0 = 0.75*(lat-17) - 2.5 - 1.0 - 2.0
if (lon > lon0 | lon < lon0 - 4.) return

llon0 = lon0 - (rup-r)*4./257.
rlon0 = lon0 - 4.

if (lon > llon0 | lon < rlon0) return

s(k) = dbeta
return
end                                                         

subroutine wedge3(r,lat,lon,s,k)
dimension s(nminv)
real lat,lon,lon0                                               

data rup /6306./
data rdown /6113./

data dbeta /-250./

if (r > rup | r < rdown) return
if (lat < 40 | lat > 45) return
lon0 = 1.25*(56.4-lat) - 2.0 - 2.0
if (lon > lon0 | lon < lon0 - 4.) return

llon0 = lon0 - (rup-r)*4./257.
rlon0 = lon0 - 4.

if (lon > llon0 | lon < rlon0) return

s(k) = dbeta
return
end

subroutine wedge4(r,lat,lon,s,k)
dimension s(nminv)
real lat,lon,lon0

data rup /6306./
data rdown /6113./

data dbeta /-250./

if (r > rup | r < rdown) return
if (lat < 44 | lat > 48) return
lon0 = 1.25*(58.2-lat) 
if (lon < lon0 | lon > lon0 + 8.) return

#llon0 = lon0 - (rup-r)*4./257.
#rlon0 = lon0 - 4.

#if (lon > llon0 | lon < rlon0) return

s(k) = dbeta
return
end

subroutine wedge5(r,lat,lon,s,k)
dimension s(nminv)
real lat,lon,lon0

data rup /6306./
data rdown /6171./

data dbeta /-250./

if (r > rup | r < rdown) return
if (lat < 34 | lat > 43) return
lon0 = 0.44*(83.75-lat) + 2.0 + 2.0 + 1.0 + 4.
if (lon < lon0 | lon > lon0 + 8.) return

#llon0 = lon0 - (rup-r)*4./257.
#rlon0 = lon0 - 4.

#if (lon > llon0 | lon < rlon0) return

s(k) = dbeta
return
end

subroutine wedge6(r,lat,lon,s,k)
dimension s(nminv)
real lat,lon,lat0,lon0

data rup /6306./
data rdown /6193./

data dbeta /-250./

if (r > rup | r < rdown) return
if (lat < 38 | lat > 44) return
lon0 = 1.25*(56.4-lat) - 2.5 - 1.0 - 7.
if (lon > lon0 | lon < lon0 - 14.) return
lat0 = 0.72*lon + 39.8
if (lat > lat0) return
							    
#llon0 = lon0 - (rup-r)*4./257.
#rlon0 = lon0 - 4.

#if (lon > llon0 | lon < rlon0) return

s(k) = dbeta
return
end

subroutine wedge7(r,lat,lon,s,k)
dimension s(nminv)
real lat,lon,lat0,lon0

data rup /6306./
data rdown /6193./

data dbeta /-250./

if (r > rup | r < rdown) return
if (lat < 36 | lat > 38) return
if (lon > 9. | lon < -2.5) return

#llon0 = lon0 - (rup-r)*4./257.
#rlon0 = lon0 - 4.

#if (lon > llon0 | lon < rlon0) return

s(k) = dbeta
return
end

subroutine crust1(r,lat,lon,s,k)
dimension s(nminv)
real lat,lon,lat0,lon0

data rup /6371./
data rdown /6301./

data dbetapiu /200./
data dbetameno /-200./

if (r > rup | r < rdown) return
if (lat > 50 | lat < 25) return
if (lon > 35 | lon < -10) return
if ((lat < 50 & lat > 45) | (lat < 40 & lat > 35) | (lat < 30 & lat > 25)) {
   if ((lon > -10 & lon < -5) | (lon > 0 & lon < 5) | (lon > 10 & lon < 15) | (lon > 20 & lon < 25) | (lon > 30 & lon < 35)) 
      s(k) = dbetapiu
   else s(k) = dbetameno
   }

if ((lat < 45 & lat > 40) | (lat < 35 & lat > 30)) {
   if ((lon > -10 & lon < -5) | (lon > 0 & lon < 5) | (lon > 10 & lon < 15) | (lon > 20 & lon < 25) | (lon > 30 & lon < 35)) 
      s(k) = dbetameno
   else s(k) = dbetapiu
   }

return
end

subroutine crust2(r,lat,lon,s,k)
dimension s(nminv)
real lat,lon,lat0,lon0

data rup /6371./
data rdown /6311./

data dbeta /-200./

if (r > rup | r < rdown) return
if (lat > 45 | lat < 38) return
if (lon > 20 | lon < 9) return

s(k) = dbeta
return
end

subroutine crust3(r,lat,lon,s,k)
dimension s(nminv)
real lat,lon,lat0,lon0

data rup /6371./
data rdown /6311./

data dbeta /200./

if (r > rup | r < rdown) return
if (lat > 45 | lat < 38) return
if (lon > 28 | lon < 21) return

s(k) = dbeta
return
end

subroutine crust4(r,lat,lon,s,k)
dimension s(nminv)
real lat,lon,lat0,lon0

data rup /6371./
data rdown /6311./

data dbeta /-200./

if (r > rup | r < rdown) return
if (lat > 37 | lat < 30) return
if (lon > 28 | lon < 21) return

s(k) = dbeta
return
end

subroutine crust5(r,lat,lon,s,k)
dimension s(nminv)
real lat,lon,lat0,lon0

data rup /6371./
data rdown /6311./

data dbeta /200./

if (r > rup | r < rdown) return
if (lat > 37 | lat < 30) return
if (lon > 20 | lon < 9) return

s(k) = dbeta
return
end

subroutine crust6(r,lat,lon,s,k)
dimension s(nminv)
real lat,lon,lat0,lon0

data rup /6371./
data rdown /6311./

data dbeta /-200./

if (r > rup | r < rdown) return
if (lat > 37 | lat < 30) return
if (lon > 8 | lon < 0) return

s(k) = dbeta
return
end

subroutine constant(r,lat,lon,s,k)
dimension s(nminv)
real lat,lon

data rup /6571./
data rdown /5271./

data dbeta /150./

if (r > rup | r < rdown) return
if (lat < 15 | lat > 60) return
if (lon < -55 | lon > 60.) return

s(k) = dbeta
return
end


SUBROUTINE SORT(N,RA,NA)
DIMENSION RA(N), NA(N)
L=N/2+1
IR=N
10 CONTINUE
IF (L.GT.1) {
   L=L-1
   RRA=RA(L)
   NNA=NA(L)
} else {
   RRA=RA(IR)
   NNA=NA(IR)
   RA(IR)=RA(1)
   NA(IR)=NA(1)
   IR=IR-1
   IF (IR.EQ.1) {
      RA(1)=RRA
      NA(1)=NNA
      RETURN
   }
}
I=L
J=L+L
20 IF (J.LE.IR) {
      IF (J.LT.IR) {
         IF (RA(J).GT.RA(J+1))J=J+1
      }  
      IF (RRA.GT.RA(J)) {
         RA(I)=RA(J)
         NA(I)=NA(J)
         I=J
         J=J+J
      } else {         
         J=IR+1
      }
      GO TO 20
  }
  RA(I)=RRA
  NA(I)=NNA
  GO TO 10
  END

subroutine setfakesmooth(stk,st,step,ksteps,mazi,w0,wc)
define pi          3.1415926535897932
define nlin        8
define ntri        3
define kmax       10    # max. nr. of steps in smoothing length.
define nonzsm    30000    # nr. of non-zeroes for smoothing matrix. (>=1!)
                        # depends on kmax.
dimension wc(kmax)

ksteps = int(st/step-0.0001)
if (ksteps <0 | ksteps > kmax) {
   write(6,*) 'No such smoothing'
   stop
}
write(6,*) 'ksteps = ',ksteps
mazi = 8
w0 = 1.
wsum = w0
do k = 1,ksteps {
#   wc(k) = 8.*(1. - k*step/st)
   wc(k) = 8.*cos(0.5*pi*k*step/st)
   wsum = wsum + k*wc(k)
}
w0 = w0/wsum
do k = 1,ksteps {
   wc(k) = wc(k)/(wsum*mazi)
}
write(6,*) stk,st,step,ksteps,mazi
write(6,*) w0,(wc(k),k=1,ksteps)

return
end

subroutine getc(xp,yp,zp,rp,tp,fp,np,i,f,out)
include defines
define nlin        8
define ntri        3
define kmax       10    # max. nr. of steps in smoothing length.
define nonzsm    30000    # nr. of non-zeroes for smoothing matrix. (>=1!)
dimension i(nonzsm),f(nonzsm)
dimension i8(nlin),f8(nlin)
dimension wc(kmax)
logical out
common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,xmin,xmax,dz,dy,dx
common/smooth/st,step,ksteps,mazi,w0,wc

# xyz grid counts from top layer, node 1 is at xmin,ymax and
# node nx is at xmax,ymax. node nx+1 is at xmin,ymax-1, etc. till
# node nx*ny. Next node is at z-1, xmin,ymax, etc.

np = 0
do l = 1,nonzsm { i(l) = 0; f(l) = 0. }

r0 = rp
t0 = tp
f0 = fp
x0 = xp
y0 = yp
z0 = zp

# check if x,y,z, is inside square grid:
# if not, return zero.
out = .false.
if (x0 < xmin | x0 > xmax | y0 < ymin | y0 > ymax | z0 < zmin | z0 > zmax) {
   out = .true. 
   return
}

#r0 = r0 + 60
r0 = r0 + 90
#do kdp = 1,3 {
do kdp = 1,4 {

call rtfxyz(0,t0,f0,r0,x0,y0,z0)
call trilin(x0,y0,z0,n8,i8,f8)
do l=1,n8 {
   call addif(i8(l),f8(l),w0,np,i,f)
}

na = 0
dcst = 0.
az = 0.
do k = 1,ksteps {
   na = na + mazi
   daz = 2.*pi/na 
   az = az + 0.5*daz
   dcst = dcst + step
   wk = wc(k)
   do ia = 1,na {
      az = az + daz
      call fiteta(f1,t1,f0,t0,az,dcst)
      call rtfxyz(0,t1,f1,r0,x1,y1,z1)
      call trilin(x1,y1,z1,n8,i8,f8)
      do l=1,n8 {
         call addif(i8(l),f8(l),wk,np,i,f)
      }
   }
}
r0 = r0 - 60.
}

return
end

subroutine trilin(xq,yq,zq,n8,i8,f8)
dimension i8(nlin),f8(nlin)
common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,xmin,xmax,dz,dy,dx

if (xq < xmin | xq > xmax | yq < ymin | yq > ymax | zq < zmin | zq > zmax) {
   n8 = 0
   return
} else {
   n8 = nlin
}

xdist = (xq - xmin)/dx
ydist = (ymax - yq)/dy
zdist = (zmax - zq)/dz

# coordinates of upper left back corner:
ixmn = int(xdist) + 1
ixmx = ixmn + 1
if (ixmn == nx) { ixmx = ixmn; ixmn = ixmx - 1 } 
iymn = int(ydist) + 1
iymx = iymn + 1
if (iymn == ny) { iymx = iymn; iymn = iymx - 1 }
izmn = int(zdist) + 1
izmx = izmn + 1
if (izmn == nz) { izmx = izmn; izmn = izmx - 1 }

lub = (izmn-1)*nxy + (iymn-1)*nx + ixmn 
i8(1) = lub
i8(2) = lub + 1
i8(3) = lub + nx
i8(4) = i8(3) + 1
i8(5) = lub + nxy
i8(6) = i8(5) + 1
i8(7) = i8(5) + nx
i8(8) = i8(7) + 1

# relative distance of point to 3 sides of cell:
x = xdist - (ixmn-1)
y = (iymx-1) - ydist
z = (izmx-1) - zdist

xy = x*y
xz = x*z
yz = y*z
xyz = xy*z

f8(1) = yz - xyz
f8(2) = xyz
f8(3) = z - yz - xz + xyz
f8(4) = xz - xyz
f8(5) = y - xy - yz + xyz
f8(6) = xy - xyz
f8(7) = 1 - x - y - z + xy + yz + xz - xyz
f8(8) = x - xy - xz + xyz

# 1 cube:
#
#        1________2 
#        /       /|
#      3/______4/ |
#       | |_____|_|6 
#       |/5     |/ 
#      7/_______/8 
#
#
# the index of a node:  i = (iz-1)*nx*ny + (iy-1)*nx + ix

return
end

subroutine addif(iin,fin,wt,n,iarr,farr)
define nonzsm    30000    # nr. of non-zeroes for smoothing matrix. (>=1!)
                        # depends on kmax.
dimension iarr(nonzsm), farr(nonzsm)

jl = 0
ju = n + 1
do while ((ju-jl) > 1) {
   jm = (ju+jl)/2
   if (iin > iarr(jm)) jl = jm
   else ju = jm
}
# this gives jl and ju so that iarr(jl) < iin <= iarr(ju)

if (iin == iarr(ju)) {
   farr(ju) = farr(ju) + wt*fin
} else {
   n = n + 1
   do j = n,ju+1,-1 {
      iarr(j) = iarr(j-1)
      farr(j) = farr(j-1)
   }
   iarr(ju) = iin
   farr(ju) = wt*fin
}

return
end


