      program makeeuv
      character*7 fname
      dimension solution(13e5),sol(13e5),stot(13e5)
      dimension jy(5),jn(5),apu(5)
      dimension wc(10)
      dimension xnode(13e5),ynode(13e5)
      logical out
      real mel,cla,clo,x1,x2,node_counter,deltaz,dist_hor
      data itypes/2/
      common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,
&     xmin,xmax,dz,dy,dx
      common/smooth/st,step,ksteps,mazi,w0,wc
      do 23000 i=1,13e5 
      solution(i) = 0.
      stot(i) = 0.
23000 continue
      open(1,file='EAV03',status='old')
      rewind 1
      read(1,*) mnnn
      read(1,*) (sol(i),i=1,mnnn)
      close(1)
      write(6,*) mnnn,' points in the model'
      call setgrid(ddd,avdd,distmax)
      open(1,file='model.shell',status='old')
      rewind(1)
      read(1,*) ntr,nt,imx,dmxd,cold,rmoho
      write(6,*) nsq,' nodes in 3D model'
      close(1)
      call setpar(njy,jy,apu,njn,jn,jmoho,apu5)
      n=0
      j=1
      do 23002 while (jy(j) .lt. itypes) 
      n = n+1
      j = j+1
23002 continue
      if(.not.(jy(j) .ne. itypes))goto 23004
      write(6,*) 'Sorry, your data do not include S-velocities,'
      write(6,*) 'I will not compute a synthetic S-velocity model.'
      stop
23004 continue
      apus=apu(j)
      ioff=n
      noff = ioff*nsq
      ncol = njy*nsq + jmoho*ntr
      write(6,*) 'offset=',noff,' apu-S=',apus,' ncol=',ncol
      z = zmax + dz
      do 23006 iz = 1, nz 
      z = z - dz
      y = ymax + dy
      do 23008 iy = 1, ny 
      y = y - dy
      x = xmin - dx
      do 23010 ix = 1, nx 
      x = x + dx
      index = index+1
      call rtfxyz(1,t,f,r,x,y,z)
      call rotate(1,t,f,tt,ft)
      t = tt/1.74533e-2
      f = ft/1.74533e-2
      call test(r,t,f,solution,index,sol)
23010 continue
23008 continue
23006 continue
      do 23012 i=1,ncol 
      stot(i) = solution(i) + sol(i)
23012 continue
      smin = 0
      smax = 0
      do 23014 i=1,ncol 
      smax = max(solution(i),smax)
      smin = min(solution(i),smin)
23014 continue
      write(6,*) 'min,max solution:',smin,smax
      fname = "syn.p00"
      open(1,file=fname,status='replace')
      rewind 1
      write(1,*) ncol
      write(1,*) (stot(i),i=1,ncol)
      close(1)
      kdp = 1
      jspk = 0
      dsol = -300.
      end
      subroutine lithosphere(r,lat,lon,s,k,sol)
      dimension s(13e5),sol(13e5)
      real lat,lon
      data rup /6341./
      data rdown /6071./
      data dbeta /+200./
      data dlimit /0./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23016
      return
23016 continue
      if(.not.(sol(k) .lt. dlimit))goto 23018
      return
23018 continue
      s(k) = dbeta
      return
      end
      subroutine asthenosphere(r,lat,lon,s,k,sol)
      dimension s(13e5),sol(13e5)
      real lat,lon
      data rup /6311./
      data rdown /6071./
      data dbeta /+200./
      data dlimit /0./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23020
      return
23020 continue
      if(.not.(sol(k) .gt. dlimit))goto 23022
      return
23022 continue
      s(k) = dbeta
      return
      end
      subroutine etna(r,lat,lon,s,k,sol)
      dimension s(13e5),sol(13e5)
      real lat,lon
      data rup /6071./
      data rdown /5711./
      data dlimit /0./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23024
      return
23024 continue
      if(.not.(lat .lt. 20 .or. lat .gt. 38))goto 23026
      return
23026 continue
      if(.not.(lon .lt. 5 .or. lon .gt. 22))goto 23028
      return
23028 continue
      if(.not.(sol(k) .gt. dlimit))goto 23030
      return
23030 continue
      s(k) = -sol(k)
      return
      end
      subroutine test(r,lat,lon,s,k,sol)
      dimension s(13e5),sol(13e5)
      real lat,lon
      data rup /6271./
      data rdown /6171./
      data dlimit /0./
      if(.not.(r .gt. rup .or. r .lt. rdown))goto 23032
      return
23032 continue
      if(.not.(lat .lt. 30 .or. lat .gt. 40))goto 23034
      return
23034 continue
      if(.not.(lon .lt. 20 .or. lon .gt. 30))goto 23036
      return
23036 continue
      if(.not.(sol(k) .lt. dlimit))goto 23038
      return
23038 continue
      s(k) = -sol(k)
      return
      end
      subroutine sort(n,ra,na)
      dimension ra(n), na(n)
      l=n/2+1
      ir=n
10    continue
      if(.not.(l.gt.1))goto 23040
      l=l-1
      rra=ra(l)
      nna=na(l)
      goto 23041
23040 continue
      rra=ra(ir)
      nna=na(ir)
      ra(ir)=ra(1)
      na(ir)=na(1)
      ir=ir-1
      if(.not.(ir.eq.1))goto 23042
      ra(1)=rra
      na(1)=nna
      return
23042 continue
23041 continue
      i=l
      j=l+l
20    if(.not.(j.le.ir))goto 23044
      if(.not.(j.lt.ir))goto 23046
      if(.not.(ra(j).gt.ra(j+1)))goto 23048
      j=j+1
23048 continue
23046 continue
      if(.not.(rra.gt.ra(j)))goto 23050
      ra(i)=ra(j)
      na(i)=na(j)
      i=j
      j=j+j
      goto 23051
23050 continue
      j=ir+1
23051 continue
      go to 20
23044 continue
      ra(i)=rra
      na(i)=nna
      go to 10
      end
      subroutine setfakesmooth(stk,st,step,ksteps,mazi,w0,wc)
      dimension wc(10)
      ksteps = int(st/step-0.0001)
      if(.not.(ksteps .lt.0 .or. ksteps .gt. 10))goto 23052
      write(6,*) 'No such smoothing'
      stop
23052 continue
      write(6,*) 'ksteps = ',ksteps
      mazi = 8
      w0 = 1.
      wsum = w0
      do 23054 k = 1,ksteps 
      wc(k) = 8.*cos(0.5*3.1415926535897932*k*step/st)
      wsum = wsum + k*wc(k)
23054 continue
      w0 = w0/wsum
      do 23056 k = 1,ksteps 
      wc(k) = wc(k)/(wsum*mazi)
23056 continue
      write(6,*) stk,st,step,ksteps,mazi
      write(6,*) w0,(wc(k),k=1,ksteps)
      return
      end
      subroutine getc(xp,yp,zp,rp,tp,fp,np,i,f,out)
      dimension i(30000),f(30000)
      dimension i8(8),f8(8)
      dimension wc(10)
      logical out
      common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,
&     xmin,xmax,dz,dy,dx
      common/smooth/st,step,ksteps,mazi,w0,wc
      np = 0
      do 23058 l = 1,30000 
      i(l) = 0
      f(l) = 0. 
23058 continue
      r0 = rp
      t0 = tp
      f0 = fp
      x0 = xp
      y0 = yp
      z0 = zp
      out = .false.
      if(.not.(x0 .lt. xmin .or. x0 .gt. xmax .or. y0 .lt. ymin .or. y0 
&     .gt. ymax .or. z0 .lt. zmin .or. z0 .gt. zmax))goto 23060
      out = .true.
      return
23060 continue
      r0 = r0 + 90
      do 23062 kdp = 1,4 
      call rtfxyz(0,t0,f0,r0,x0,y0,z0)
      call trilin(x0,y0,z0,n8,i8,f8)
      do 23064 l=1,n8 
      call addif(i8(l),f8(l),w0,np,i,f)
23064 continue
      na = 0
      dcst = 0.
      az = 0.
      do 23066 k = 1,ksteps 
      na = na + mazi
      daz = 2.*3.1415926535897932/na
      az = az + 0.5*daz
      dcst = dcst + step
      wk = wc(k)
      do 23068 ia = 1,na 
      az = az + daz
      call fiteta(f1,t1,f0,t0,az,dcst)
      call rtfxyz(0,t1,f1,r0,x1,y1,z1)
      call trilin(x1,y1,z1,n8,i8,f8)
      do 23070 l=1,n8 
      call addif(i8(l),f8(l),wk,np,i,f)
23070 continue
23068 continue
23066 continue
      r0 = r0 - 60.
23062 continue
      return
      end
      subroutine trilin(xq,yq,zq,n8,i8,f8)
      dimension i8(8),f8(8)
      common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,
&     xmin,xmax,dz,dy,dx
      if(.not.(xq .lt. xmin .or. xq .gt. xmax .or. yq .lt. ymin .or. yq 
&     .gt. ymax .or. zq .lt. zmin .or. zq .gt. zmax))goto 23072
      n8 = 0
      return
23072 continue
      n8 = 8
23073 continue
      xdist = (xq - xmin)/dx
      ydist = (ymax - yq)/dy
      zdist = (zmax - zq)/dz
      ixmn = int(xdist) + 1
      ixmx = ixmn + 1
      if(.not.(ixmn .eq. nx))goto 23074
      ixmx = ixmn
      ixmn = ixmx - 1 
23074 continue
      iymn = int(ydist) + 1
      iymx = iymn + 1
      if(.not.(iymn .eq. ny))goto 23076
      iymx = iymn
      iymn = iymx - 1 
23076 continue
      izmn = int(zdist) + 1
      izmx = izmn + 1
      if(.not.(izmn .eq. nz))goto 23078
      izmx = izmn
      izmn = izmx - 1 
23078 continue
      lub = (izmn-1)*nxy + (iymn-1)*nx + ixmn
      i8(1) = lub
      i8(2) = lub + 1
      i8(3) = lub + nx
      i8(4) = i8(3) + 1
      i8(5) = lub + nxy
      i8(6) = i8(5) + 1
      i8(7) = i8(5) + nx
      i8(8) = i8(7) + 1
      x = xdist - (ixmn-1)
      y = (iymx-1) - ydist
      z = (izmx-1) - zdist
      xy = x*y
      xz = x*z
      yz = y*z
      xyz = xy*z
      f8(1) = yz - xyz
      f8(2) = xyz
      f8(3) = z - yz - xz + xyz
      f8(4) = xz - xyz
      f8(5) = y - xy - yz + xyz
      f8(6) = xy - xyz
      f8(7) = 1 - x - y - z + xy + yz + xz - xyz
      f8(8) = x - xy - xz + xyz
      return
      end
      subroutine addif(iin,fin,wt,n,iarr,farr)
      dimension iarr(30000), farr(30000)
      jl = 0
      ju = n + 1
      do 23080 while ((ju-jl) .gt. 1) 
      jm = (ju+jl)/2
      if(.not.(iin .gt. iarr(jm)))goto 23082
      jl = jm
      goto 23083
23082 continue
      ju = jm
23083 continue
23080 continue
      if(.not.(iin .eq. iarr(ju)))goto 23084
      farr(ju) = farr(ju) + wt*fin
      goto 23085
23084 continue
      n = n + 1
      do 23086 j = n,ju+1,-1 
      iarr(j) = iarr(j-1)
      farr(j) = farr(j-1)
23086 continue
      iarr(ju) = iin
      farr(ju) = wt*fin
23085 continue
      return
      end
