program makeeuv
include defines
define nlin        8
define ntri        3
define kmax       10    # max. nr. of steps in smoothing length.
define nonzsm    30000    # nr. of non-zeroes for smoothing matrix. (>=1!)
                        # depends on kmax.
include worklims
include workdefs
include sdefines
define nspik 2
define ndip 1
#
define nspk 50
define ndp 1
# makes synthetic model for S-velocity, using EAV03 as base.
character*7 fname
dimension solution(nminv),sol(nminv),stot(nminv)
dimension jy(nrfpr),jn(nrfpr),apu(nrfpr)
dimension wc(10)
dimension xnode(nminv),ynode(nminv)
logical out
real mel,cla,clo,x1,x2,node_counter,deltaz,dist_hor
data itypeS/2/
common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,xmin,xmax,dz,dy,dx
common/smooth/st,step,ksteps,mazi,w0,wc

#It is maintaining the crust of the used model, in this case EAV03

do i=1,nminv {
   solution(i) = 0.
   stot(i) = 0.
}

open(1,file='EAV03',status='old') 
rewind 1
read(1,*) mnnn
read(1,*) (sol(i),i=1,mnnn)
close(1)
write(6,*) mnnn,' points in the model'

call setgrid(ddd,avdd,distmax)
open(1,file='model.shell',status='old')
rewind(1)
read(1,*) ntr,nt,imx,dmxd,cold,rmoho
write(6,*) nsq,' nodes in 3D model'
close(1)
call setpar(njy,jy,apu,njn,jn,jmoho,apu5)
n=0
j=1
do while (jy(j) < itypeS) {
   n = n+1
   j = j+1
}
if (jy(j) != itypeS) {
   write(6,*) 'Sorry, your data do not include S-velocities,'
   write(6,*) 'I will not compute a synthetic S-velocity model.'
   stop
}
apus=apu(j)
ioff=n
noff = ioff*nsq
ncol = njy*nsq + jmoho*ntr
write(6,*) 'offset=',noff,' apu-S=',apus,' ncol=',ncol
#node_counter = 0

# realistic model: 
##open(2,file='nodes',status='new')
#index = noff
z = zmax + dz
do iz = 1, nz {
   z = z - dz
###   z=6371.00
   y = ymax + dy
   do iy = 1, ny {
      y = y - dy
      x = xmin - dx
      do ix = 1, nx {
         x = x + dx
         index = index+1
##	 dist_hor = sqrt(x*x+y*y)
### deltaz = 6371.00-sqrt(6371.00*6371.00-dist_hor*dist_hor)
##        call rtfxyz(1,t,f,r,x,y,z-deltaz)
         call rtfxyz(1,t,f,r,x,y,z)
         call rotate(1,t,f,tt,ft)
         t = tt/p
         f = ft/p
####	 if (r == 6371.00) {
#####            xnode(index) = t
####            ynode(index) = f
####            node_counter = node_counter + 1
###         } else {write(6,*) t,f,r}
###         write(2,*) xnode(index), ynode(index), r
#         call lithosphere(r,t,f,solution,index,sol)
#         call asthenosphere(r,t,f,solution,index,sol)
#	  call etna(r,t,f,solution,index,sol)
	  call test(r,t,f,solution,index,sol)
      }
   }
} 
##write(6,*) 'plotted nodes = ',node_counter
##write(6,*) 'ymax = ',ymax
##close(2)
#
#x = xmax
#y = 0
#z = 6371
#call rtfxyz(1,t,f,r,x,y,z)
#write (6,*) 'newlat : ',t/p,' newlon : ',f/p
#x = xmax
#y = 0
#z = 6071
#call rtfxyz(1,t,f,r,x,y,z)
#write (6,*) 'newlat : ',t/p,' newlon : ',f/p
#t = 0
#f = 0
#call rotate(1,t,f,tt,ft)
#t = tt/p
#f = ft/p
#write (6,*) 'lat : ',t,' lon : ',f

do i=1,ncol {
   stot(i) = solution(i) + sol(i)
}

smin = 0
smax = 0
do i=1,ncol {
#   if (solution(i) == 0.) {
#      solution(i) = -150.
#   }
   smax = max(solution(i),smax)
   smin = min(solution(i),smin)
}
write(6,*) 'min,max solution:',smin,smax
fname = "syn.p00"
open(1,file=fname,status='replace')
rewind 1
write(1,*) ncol
write(1,*) (stot(i),i=1,ncol)
close(1)

kdp = 1
jspk = 0
dsol = -300.


end

subroutine lithosphere(r,lat,lon,s,k,sol)
dimension s(nminv),sol(nminv)
real lat,lon

data rup /6341./
data rdown /6071./

data dbeta /+200./
data dlimit /0./

if (r > rup | r < rdown) {
	return
}	
if (sol(k) < dlimit) {
	return
}

s(k) = dbeta
return
end

subroutine asthenosphere(r,lat,lon,s,k,sol)
dimension s(nminv),sol(nminv)
real lat,lon

data rup /6311./
data rdown /6071./

data dbeta /+200./
data dlimit /0./

if (r > rup | r < rdown) {
	return
}	
if (sol(k) > dlimit) {
	return
}

s(k) = dbeta
return
end

subroutine etna(r,lat,lon,s,k,sol)
dimension s(nminv),sol(nminv)
real lat,lon

data rup /6071./
data rdown /5711./

data dlimit /0./

if (r > rup | r < rdown) {
	return
}
if (lat < 20 | lat > 38) {
        return
}
if (lon < 5 | lon > 22) {
        return
}
if (sol(k) > dlimit) {
	return
}

s(k) = -sol(k)
return
end

subroutine test(r,lat,lon,s,k,sol)
dimension s(nminv),sol(nminv)
real lat,lon

data rup /6271./
data rdown /6171./

data dlimit /0./

if (r > rup | r < rdown) {
	return
}
if (lat < 30 | lat > 40) {
        return
}
if (lon < 20 | lon > 30) {
        return
}
if (sol(k) < dlimit) {
	return
}

s(k) = -sol(k)
return
end

SUBROUTINE SORT(N,RA,NA)
DIMENSION RA(N), NA(N)
L=N/2+1
IR=N
10 CONTINUE
IF (L.GT.1) {
   L=L-1
   RRA=RA(L)
   NNA=NA(L)
} else {
   RRA=RA(IR)
   NNA=NA(IR)
   RA(IR)=RA(1)
   NA(IR)=NA(1)
   IR=IR-1
   IF (IR.EQ.1) {
      RA(1)=RRA
      NA(1)=NNA
      RETURN
   }
}
I=L
J=L+L
20 IF (J.LE.IR) {
      IF (J.LT.IR) {
         IF (RA(J).GT.RA(J+1))J=J+1
      }  
      IF (RRA.GT.RA(J)) {
         RA(I)=RA(J)
         NA(I)=NA(J)
         I=J
         J=J+J
      } else {         
         J=IR+1
      }
      GO TO 20
  }
  RA(I)=RRA
  NA(I)=NNA
  GO TO 10
  END

subroutine setfakesmooth(stk,st,step,ksteps,mazi,w0,wc)
define pi          3.1415926535897932
define nlin        8
define ntri        3
define kmax       10    # max. nr. of steps in smoothing length.
define nonzsm    30000    # nr. of non-zeroes for smoothing matrix. (>=1!)
                        # depends on kmax.
dimension wc(kmax)

ksteps = int(st/step-0.0001)
if (ksteps <0 | ksteps > kmax) {
   write(6,*) 'No such smoothing'
   stop
}
write(6,*) 'ksteps = ',ksteps
mazi = 8
w0 = 1.
wsum = w0
do k = 1,ksteps {
#   wc(k) = 8.*(1. - k*step/st)
   wc(k) = 8.*cos(0.5*pi*k*step/st)
   wsum = wsum + k*wc(k)
}
w0 = w0/wsum
do k = 1,ksteps {
   wc(k) = wc(k)/(wsum*mazi)
}
write(6,*) stk,st,step,ksteps,mazi
write(6,*) w0,(wc(k),k=1,ksteps)

return
end

subroutine getc(xp,yp,zp,rp,tp,fp,np,i,f,out)
include defines
define nlin        8
define ntri        3
define kmax       10    # max. nr. of steps in smoothing length.
define nonzsm    30000    # nr. of non-zeroes for smoothing matrix. (>=1!)
dimension i(nonzsm),f(nonzsm)
dimension i8(nlin),f8(nlin)
dimension wc(kmax)
logical out
common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,xmin,xmax,dz,dy,dx
common/smooth/st,step,ksteps,mazi,w0,wc

# xyz grid counts from top layer, node 1 is at xmin,ymax and
# node nx is at xmax,ymax. node nx+1 is at xmin,ymax-1, etc. till
# node nx*ny. Next node is at z-1, xmin,ymax, etc.

np = 0
do l = 1,nonzsm { i(l) = 0; f(l) = 0. }

r0 = rp
t0 = tp
f0 = fp
x0 = xp
y0 = yp
z0 = zp

# check if x,y,z, is inside square grid:
# if not, return zero.
out = .false.
if (x0 < xmin | x0 > xmax | y0 < ymin | y0 > ymax | z0 < zmin | z0 > zmax) {
   out = .true. 
   return
}

#r0 = r0 + 60
r0 = r0 + 90
#do kdp = 1,3 {
do kdp = 1,4 {

call rtfxyz(0,t0,f0,r0,x0,y0,z0)
call trilin(x0,y0,z0,n8,i8,f8)
do l=1,n8 {
   call addif(i8(l),f8(l),w0,np,i,f)
}

na = 0
dcst = 0.
az = 0.
do k = 1,ksteps {
   na = na + mazi
   daz = 2.*pi/na 
   az = az + 0.5*daz
   dcst = dcst + step
   wk = wc(k)
   do ia = 1,na {
      az = az + daz
      call fiteta(f1,t1,f0,t0,az,dcst)
      call rtfxyz(0,t1,f1,r0,x1,y1,z1)
      call trilin(x1,y1,z1,n8,i8,f8)
      do l=1,n8 {
         call addif(i8(l),f8(l),wk,np,i,f)
      }
   }
}
r0 = r0 - 60.
}

return
end

subroutine trilin(xq,yq,zq,n8,i8,f8)
dimension i8(nlin),f8(nlin)
common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,xmin,xmax,dz,dy,dx

if (xq < xmin | xq > xmax | yq < ymin | yq > ymax | zq < zmin | zq > zmax) {
   n8 = 0
   return
} else {
   n8 = nlin
}

xdist = (xq - xmin)/dx
ydist = (ymax - yq)/dy
zdist = (zmax - zq)/dz

# coordinates of upper left back corner:
ixmn = int(xdist) + 1
ixmx = ixmn + 1
if (ixmn == nx) { ixmx = ixmn; ixmn = ixmx - 1 } 
iymn = int(ydist) + 1
iymx = iymn + 1
if (iymn == ny) { iymx = iymn; iymn = iymx - 1 }
izmn = int(zdist) + 1
izmx = izmn + 1
if (izmn == nz) { izmx = izmn; izmn = izmx - 1 }

lub = (izmn-1)*nxy + (iymn-1)*nx + ixmn 
i8(1) = lub
i8(2) = lub + 1
i8(3) = lub + nx
i8(4) = i8(3) + 1
i8(5) = lub + nxy
i8(6) = i8(5) + 1
i8(7) = i8(5) + nx
i8(8) = i8(7) + 1

# relative distance of point to 3 sides of cell:
x = xdist - (ixmn-1)
y = (iymx-1) - ydist
z = (izmx-1) - zdist

xy = x*y
xz = x*z
yz = y*z
xyz = xy*z

f8(1) = yz - xyz
f8(2) = xyz
f8(3) = z - yz - xz + xyz
f8(4) = xz - xyz
f8(5) = y - xy - yz + xyz
f8(6) = xy - xyz
f8(7) = 1 - x - y - z + xy + yz + xz - xyz
f8(8) = x - xy - xz + xyz

# 1 cube:
#
#        1________2 
#        /       /|
#      3/______4/ |
#       | |_____|_|6 
#       |/5     |/ 
#      7/_______/8 
#
#
# the index of a node:  i = (iz-1)*nx*ny + (iy-1)*nx + ix

return
end

subroutine addif(iin,fin,wt,n,iarr,farr)
define nonzsm    30000    # nr. of non-zeroes for smoothing matrix. (>=1!)
                        # depends on kmax.
dimension iarr(nonzsm), farr(nonzsm)

jl = 0
ju = n + 1
do while ((ju-jl) > 1) {
   jm = (ju+jl)/2
   if (iin > iarr(jm)) jl = jm
   else ju = jm
}
# this gives jl and ju so that iarr(jl) < iin <= iarr(ju)

if (iin == iarr(ju)) {
   farr(ju) = farr(ju) + wt*fin
} else {
   n = n + 1
   do j = n,ju+1,-1 {
      iarr(j) = iarr(j-1)
      farr(j) = farr(j-1)
   }
   iarr(ju) = iin
   farr(ju) = wt*fin
}

return
end
