program oceanmoho
# to write point constraints for oceanic moho
# compile: f77 -o ../../bin/oceanmoho oceanmoho.r ../rotate.o ../etopo5.o ../setgrid.o ../checkmodel.o
include defines
dimension tt(mxtr), pp(mxtr)
dimension cols(nmxsq)
common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,xmin,xmax,dz,dy,dx

call setgrid(ddd,avdd,distmax)
open(1,file='model.shell',status='old')
read(1,*) ntr,nt,imx,dmxd,cold,rmoho
read(1,*) (tt(k),k=1,ntr)
read(1,*) (pp(k),k=1,ntr)
close(1)

open(3,file='columnsums',status='old')
rewind 3
read(3,*) ncs
read(3,*) (cols(i),i=1,ncs)
close(3)
if ((nsq+ntr)!=ncs) {
   print*, "Error", nsq,ntr,ncs
   stop
}

open(2,file='pointdata.ocean')
rewind 2

omd = 10.

do i=1,ntr {
   call rotate(1,tt(i),pp(i),plat,plon)
   plat = plat/p
   plon = plon/p
   if (cols(nsq+i) > 0.00001) {
      topo = etopo5(plat,plon)
      if (topo<-2000.) {
	  if (plon<-2) {
             write(2,*) plat,plon,omd
	  }
	  if (plon>=-2 & plon<0 & plat>40) {
	     write(2,*) plat,plon,omd
	  }
      }
   }
}

close(2)
end
