program phsmcomb
# c. SVDL  2000
#
# this program computes a matrix for point velocity estimates.
# it is glued to the original matrix by a version of program 
# "glue.r", i.e. glue0.r 
# dnv3e.r is run finally to invert for model coefficients.
# 
include defines
include sdefines
dimension tt(mxtr),pp(mxtr),jy(nrfpr),apu(nrfpr),jn(nrfpr),iq(nonzsm),pq(nonzsm)
dimension wc(kmax)
logical out
character*72 pdfn
common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,xmin,xmax,dz,dy,dx
common/smooth/st,step,ksteps,mazi,w0,wc

open(1,file='model.shell',status='old')
rewind 1
read(1,*)ntr,nt,imx,dmxd,cold,rmoho
write(6,*)'reading model.shell'
write(6,*)'ntr,nt,imx,dmxd,cold,rmoho',ntr,nt,imx,dmxd,cold,rmoho
refmohodep=(radius-rmoho)
read(1,*) (tt(k),k=1,ntr)
read(1,*) (pp(k),k=1,ntr)
close (1)
#convert to radians
dmx = dmxd*p
col = cold*p

call setgrid(ddd,avdd,distmax)

call setpar(njy,jy,apu,njn,jn,jmoho,apu5)
#inofset = nsq*njy
inofset = 0
narg = iargc()
if (narg != 1) {print*, "Usage: phsmcomb pointdatafile"; stop }
call getarg(1,pdfn)
open(3,file=pdfn, status='old')
rewind 3
read(3,*) nd

open(4,file='pmatrix',status='new')
rewind 4
open(7,file='prhs',status='new')
rewind 7
open(9,file='psizeofmatrix',status='new')
rewind 9

#open(8,file='smooth',status='old')
#rewind 8
#read(8,*)stk,st,step,ksteps,mazi,w0,(wc(k),k=1,ksteps)
#write(6,*)'reading smooth....'
#write(6,*)stk,st,step,ksteps,mazi,w0,(wc(k),k=1,ksteps)
write(6,*) 'Give smoothing radius and step (km):'
read(5,*) stk, stepk
#stk = 240.
st = stk/radius
#step = 40./radius
step = stepk/radius
call setfakesmooth(stk,st,step,ksteps,mazi,w0,wc)
write(6,*)stk,st,step,ksteps,mazi,w0,(wc(k),k=1,ksteps)

nmmxp = 0
idata=0
write(6,*)'reading points.....'
print*, nd, ' points'
nq0 = 0
nout = 0
do i=1,nd  {
  read(3,*)plon,plat,ra,pot
  # proceed in radians:
  plat=plat*p
  plon=plon*p
  call rotate(0,plat,plon,elat,elon)
  call rtfxyz(0,elat,elon,ra,x,y,z)
  call getc(x,y,z,ra,elat,elon,nq,iq,pq,out)
  nmmxp = max(nmmxp,nq)
  if (out) nout=nout+1
    
  if(nq>0) {
    idata=idata+1   
    write(4,*) idata,1,nq
    write(4,*) (iq(j)+inofset,j=1,nq)
    write(4,*) (pq(j),j=1,nq)
    write(7,*) pot 
  } else {
    nq0 = nq0 + 1
  }
}
print*, 'idata=',idata
print*, nq0,' points had no nodes'
print*, nout,' points were outside grid'
write(9,*) idata,nsq+ntr,nmmxp,idata

end


subroutine setfakesmooth(stk,st,step,ksteps,mazi,w0,wc)
define pi          3.1415926535897932
define nlin        8
define ntri        3
define kmax       10    # max. nr. of steps in smoothing length.
define nonzsm    30000    # nr. of non-zeroes for smoothing matrix. (>=1!)
                        # depends on kmax.
dimension wc(kmax)

ksteps = int(st/step-0.0001)
if (ksteps <0 | ksteps > kmax) {
   write(6,*) 'No such smoothing'
   stop
}
write(6,*) 'ksteps = ',ksteps
mazi = 8
w0 = 1.
wsum = w0
do k = 1,ksteps {
#   wc(k) = 8.*(1. - k*step/st)
   wc(k) = 8.*cos(0.5*pi*k*step/st)
   wsum = wsum + k*wc(k)
}
w0 = w0/wsum
do k = 1,ksteps {
   wc(k) = wc(k)/(wsum*mazi)
}
write(6,*) stk,st,step,ksteps,mazi
write(6,*) w0,(wc(k),k=1,ksteps)

return
end

