# to smooth and (optionally) slice the solution of dnv3e.
# c 1996 SL

include workdefs
include worklims
include sdefines
include slicedefs
define ncubelen 500
define extreme 100000.

dimension pq(nonzsm),iq(nonzsm)
dimension pql(nlin),iql(nlin)
dimension pt(nonzsm),it(nonzsm)
dimension ptl(ntri),itl(ntri)
dimension sol(nminv)
dimension cols(nminv)
dimension asol(ncubelen,ncubelen)
dimension a3d(nminv),c3d(nminv)
dimension asav(300)
dimension br(300)
dimension by(300,4)
#integer*1 na3d(nminv),nc3d(nminv)
character*1 na3d(nminv),nc3d(nminv)
dimension cs(ncubelen,ncubelen)
character*15 txt(nrfpr)
character*50 slicename, argv, mohoname, toponame
character*52 colname 
character*2 aflg
character*4 bname
dimension jy(nrfpr)
dimension tt(mxtr),pp(mxtr)
dimension wc(kmax)
logical out,black,leps,exag,back,relat
data txt/'P-wave velocity','S-wave velocity','density','Shear Quality','Moho depth'/
#data cseps/0.000001/
#data cseps/0.02/     # South America
#data cseps/0.06/
#data cseps/0.002/     # moma
common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,xmin,xmax,dz,dy,dx
common/smooth/st,step,ksteps,mazi,w0,wc

write(6,*) 'program sns:'
10 format(a,$ )
20 format('#',1x,a16,1x,6f9.2)
30 format(i4,a17,5f8.2)
40 format(2f9.2)

inquire(file='epsilon',exist=leps)
if (leps) {
  open(1,file='epsilon')
  read(1,*) cseps
  close(1)
} else {
# for apu-scaled columnsums:
#  cseps = 0.02
# for un-scaled columnsums:
  cseps = 0.0001
}
#write(6,*) 'epsilon (max colsum for blackout) = ',cseps

inquire(file='topoexag',exist=exag)
if (exag) {
  open(1,file='topoexag')
  read(1,*) topoexag
  close(1)
} else {
  topoexag = 10.
}

iar = iargc()
relat=.false.
if (iar == 1) {
   call getarg(iar,argv)
   black = .false.
   back = .false.
} else if (iar > 1) {
   do ia = 1,iar-1 {
      call getarg(ia,aflg)
      if (aflg == '-w') {
         inquire(file='columnsums',exist=black)
         if (! black) {write(6,*) 'error: file columnsums does not exist'}
         write(6,*) 'epsilon (max colsum for blackout) = ',cseps
      } else if (aflg == '-a') {
         inquire(file='backgroundmodel',exist=back)
         if (! back) {write(6,*) 'error: file backgroundmodel does not exist'}
      } else if (aflg == '-r') {
         inquire(file='backgroundmodel',exist=back)
         if (! back) {write(6,*) 'error: file backgroundmodel does not exist'}
	 relat = .true.
      }
   }
   call getarg(iar,argv)
} else {
   write(6,*) 'Usage: sns [-w] [-a/-r] modelname'
   write(6,*) ''
   stop
} 
if (black) {
   write(6,*) 'file columnsums used to white-out unsampled areas'
}
if (back) {
   open(1,file='backgroundmodel',status='old')
   read(1,*) bname
   write(6,*) 'backgroundmodel used = ',bname
   read(1,*) 
   read(1,*) nba, nbi, nbo
   nbc = nbi + nbo
   do i = 1,nbc { read(1,*) }
   nba = nba - nbc
   do i = 1,nba {
      read(1,*) br(i),by(i,3),by(i,1),by(i,2),dum,by(i,4)
      br(i) = 0.001*br(i)
      by(i,1) = 0.001*by(i,1)
      by(i,2) = 0.001*by(i,2)
      by(i,3) = 0.001*by(i,3)
# work with 1/1000 of Qs (for consistency with output in km/s)
      by(i,4) = 0.001*by(i,4)
   }
   close(1)
## finterp testing:
#   open(44,file='zozo1')
#   rewind 44
#   open(45,file='zozo2')
#   rewind 45
#   do i=0,67 {
#      r = 6371. - 670. + i*10.
#      bas = finterp(r,br,by(1,3),nba)
#      write(44,*) r,bas
#   }
#   do i=1,nba {
#      write(45,*) br(i),by(i,3)
#   }
#   close(44)
#   close(45)
}

do i = 1,ncubelen {
   do j = 1,ncubelen {
      asol(i,j) = 0.
      cs(i,j) = 0.
   }
}

open(1,file='model.cube',status='old')
rewind 1
read(1,*) ola,olo,oazi,nz,ny,nx,zmin,zmax,ymin,ymax,xmin,xmax,dz,dy,dx
close(1)
write(6,*) 'read model.cube'
ola = ola*p
olo = olo*p
oazi = oazi*p
nxy = nx*ny
nsq = nxy*nz

# get correlation length for smoothing:
open(1,file='smooth',status='old')
rewind 1
read(1,*) stk,st,step,ksteps,mazi,w0,(wc(k),k=1,ksteps)
close(1) 
write(6,*) 'read smooth'
write(6,*) 'stk = ',stk,' km'

open(1,file='parcom',status='old')
rewind 1
read(1,*) njy
read(1,*) (jy(j),j=1,njy)
close(1)
write(6,*) 'read parcom'

do j=1,njy {
   if (jy(j)==5) { 
      jmoho = 1
   } else {
      jmoho = 0
   }
}
if (jmoho==1) {
# read model.shell in case it's needed.
   open(1,file='model.shell',status='old')
   rewind 1
   read(1,*) ntr,nt,imx,dmxd,cold,rmoho
   read(1,*) (tt(k),k=1,ntr)
   read(1,*) (pp(k),k=1,ntr)
   close(1)
   write(6,*) 'read model.shell'
   col = cold*p
   dmx = dmxd*p
}

open(1,file=argv,status='old')
rewind 1
read(1,*) mnnn
read(1,*) (sol(i),i=1,mnnn)
close(1)
write(6,*) 'read ',argv

if (black) {
   open(1,file='columnsums',status='old')
   rewind 1
   read(1,*) mncl
   if (mncl != mnnn) {
      write(6,*) 'error: # of elements from columnsums and model not compatible'
      stop
   }
   read(1,*) (cols(i),i=1,mncl)
   close(1)
   write(6,*) 'read columnsums'
}

jchoice = 0
iopt = 0

write(6,*) 'solution contains:'
do j=1,njy { write(6,*) j,' ',txt(jy(j)) }
do while (jchoice < 1 | jchoice > 5) {
   write(6,10) 'which parameter (give number):'
   read(5,*) jchoice }
ioff = (jchoice-1)*nsq 
ioffm = (njy-1)*nsq
kb = jy(jchoice)
if (jy(jchoice) == 5) {
   rshell = rmoho
   iopt = -3
   write(6,*) 'slice type, option -3'
}

if (iopt == 0) {
   write(6,*) 'select slice type, options:'
   write(6,*) '1) latitude, longitude, azimuth, delta, depth-extent'
   write(6,*) '2) latitude1, longitude1, latitude2, longitude2, depth-extent'
   write(6,*) '3) depth = constant, latmin, latmax, lonmin, lonmax'
   write(6,*) '4) brick as is (in cartesian grid)'
   write(6,*) '5) brick in lon, lat, r' 
   write(6,*) 'all in km or degrees'
   write(6,*) '6) 1-D model'
   do while (iopt < 1 || iopt > 6) {
      write(6,10) 'selected option: ' 
      read(5,*) iopt }
}
if (iopt == 6 && back == .false.) {
   write(6,*) 'Option 6 only possible with "-a" or "-r" flag'
   stop
}

write(6,10) "give filename for output: "
read(5,'(a)') slicename
write(6,*) slicename
colname = 'cl'//slicename
mohoname = 'mh'//slicename
toponame = 'tp'//slicename

# preparational:
if (iopt == 1) {
   open(2,file=slicename)
   rewind 2
   if (black) {
      write(6,*) colname
      open(4,file=colname)
      rewind 4
   }
   write(6,*) 'give latitude1, longitude1, azimuth, delta, depth-extent: '
   read(5,*) xlat1,xlon1,azimuth,delta,depth
   write(6,10) 'Give ddelta and ddepth:'
   read(5,*) da,db
   xlat1 = xlat1*p
   xlon1 = xlon1*p
   delta = delta*p
   azimuth = azimuth*p
   call fiteta(fi2,teta2,xlon1,xlat1,azimuth,delta)
   xlon2 = fi2
   xlat2 = teta2
   write(6,*) 'To:',xlat2/p,xlon2/p
   call rotate(0,xlat1,xlon1,tetaout,fiout)
   xlat1 = tetaout
   xlon1 = fiout
   call rotate(0,xlat2,xlon2,tetaout,fiout)
   xlat2 = tetaout
   xlon2 = fiout
   call epdist(xlat1,xlon1,xlat2,xlon2,delta,azimuth)
   rup = radius
   rdown = radius - depth
}
if (iopt == 2) {
   open(2,file=slicename)
   rewind 2
   if (black) {
      write(6,*) colname
      open(4,file=colname)
      rewind 4
   }
   write(6,*) 'give latitude1, longitude1, latitude2, longitude2, depth-extent: '
   read(5,*) xlat1,xlon1,xlat2,xlon2,depth
   write(6,10) 'Give ddelta and ddepth:'
   read(5,*) da,db
   xlat1 = xlat1*p
   xlat2 = xlat2*p
   xlon1 = xlon1*p
   xlon2 = xlon2*p
   call rotate(0,xlat1,xlon1,tetaout,fiout)
   xlat1 = tetaout
   xlon1 = fiout
   call rotate(0,xlat2,xlon2,tetaout,fiout)
   xlat2 = tetaout
   xlon2 = fiout
   call epdist(xlat1,xlon1,xlat2,xlon2,delta,azimuth)
   write(6,*) 'distance is ',delta/p,' degrees'
   rup = radius
   rdown = radius - depth
   iopt = 1
}
if (iopt == 3) {
   open(2,file=slicename)
   rewind 2
   if (black) {
      write(6,*) colname
      open(4,file=colname)
      rewind 4
   }
   write(6,*) 'give depth of layer, latmin, latmax, lonmin, lonmax: '
   read(5,*) rshell,atmin,atmax,onmin,onmax
   write(6,10) 'Give dlat and dlon:'
   read(5,*) db,da
   rshell = radius - rshell
}
if (iopt == -3) {
   open(2,file=slicename)
   rewind 2
   if (black) {
      write(6,*) colname
      open(4,file=colname)
      rewind 4
   }
   write(6,*) 'give latmin, latmax, lonmin, lonmax: '
   read(5,*) atmin,atmax,onmin,onmax
   write(6,10) 'Give dlat and dlon:'
   read(5,*) db,da
}
if (iopt == 3 || iopt == -3) {
   atmin = atmin*p
   onmin = onmin*p
   atmax = atmax*p
   onmax = onmax*p
      da = da*p
      db = db*p
      amin = onmin
      amax = onmax
      bmin = atmin
      bmax = atmax
      sc = 1./p
   arange = amax-amin
   brange = bmax-bmin
   na = nint(arange/da) + 1
   nb = nint(brange/db) + 1
   if (nb > ncubelen | na > ncubelen) {
      write(6,*) "Dimension of asol exceeded!"
      stop
   }
}
if (iopt == 4 | iopt == 5) {
   open(2,file=slicename)
   rewind 2
   if (black) {
      open(4,file=colname)
      rewind 4
   }
}
if (iopt == 5) {
   write(6,*) 'give depthmin, depthmax, latmin, latmax, lonmin, lonmax: '
   read(5,*) depthmin,depthmax,atmin,atmax,onmin,onmax
   write(6,10) 'Give ddelta and ddepth:'
   read(5,*) da,db
   rup = radius - depthmin
   rdown = radius - depthmax
   range = rup - rdown
# two input increments: da,db. da = dlat = dlon and db = ddepth = dr
   nr = nint(range/db) + 1
   dr = db
   amin = atmin*p
   amax = atmax*p
   bmin = onmin*p
   bmax = onmax*p
   arange = amax-amin
   brange = bmax-bmin
   ddelta = ddelta/radius
   na = nint(arange/da) + 1
   nb = nint(brange/da) + 1
   db = da
}
if (iopt == 6) {
   open(2,file=slicename)
   rewind 2
   write(6,*) 'give latitude1, longitude1, latitude2, longitude2, depth-extent:'
   read(5,*) xlat1,xlon1,xlat2,xlon2,depth
   write(6,10) 'Give ddelta:'
   read(5,*) da
   xlat1 = xlat1*p
   xlat2 = xlat2*p
   xlon1 = xlon1*p
   xlon2 = xlon2*p
   call rotate(0,xlat1,xlon1,tetaout,fiout)
   xlat1 = tetaout
   xlon1 = fiout
   call rotate(0,xlat2,xlon2,tetaout,fiout)
   xlat2 = tetaout
   xlon2 = fiout
   call epdist(xlat1,xlon1,xlat2,xlon2,delta,azimuth)
   write(6,*) 'distance is ',delta/p,' degrees'
   rup = radius
   rdown = radius - depth
}
# at this point all variables are in radians and km.
cmax = 0.
asmax = -1.*extreme
asmin = extreme

#real work, construct "asol" for plot-file:
if (iopt == 1) {
   open(10,file=mohoname)
   rewind 10
   open(11,file=toponame)
   rewind 11
   # we know: xlat1 xlon1 delta azimuth rup rdown xlat2 xlon2
   range = rup - rdown
   dr = db
   nb = nint(range/db) + 1
   da = da*p
   na = nint(delta/da) + 1
   if (nb > ncubelen | na > ncubelen) {
      write(6,*) "Dimension of asol exceeded!"
      stop
   }
   print*, "slicing..."
   acoor = 90. + 0.5*delta/p
   dacoor = da/p
   do i = 1,na {
      do j = 1,nb {
	 as = 0.
	 r = (rup - (j-1)*dr)
	 call rtfxyz(0,xlat1,xlon1,r,x,y,z)
         call getc(x,y,z,r,xlat1,xlon1,nq,iq,pq,out)
         do l=1,nq {
            as = as + pq(l)*sol(ioff + iq(l))
	 }
	 if (back) {
            bas = finterp(r,br,by(1,kb),nba)
	    if (relat) {
	       as = 0.1*as/bas
	    } else {
	       as = bas + 0.001*as
            }
         }
	 if (as>asmax) {
	    asmax = as
	    elamax = acoor*p
	    elomax = r*p
	 }
	 if (as<asmin) {
	    asmin = as
	    elamin = acoor*p
	    elomin = r*p
	 }
	 if (black) {
	    cst = 0.
            call getclin(x,y,z,nql,iql,pql,out)
	    do l=1,nql {
	       cst = cst + pql(l)*cols(ioff+iql(l))
	    }
	    if (cst < cseps) { 
	       as = extreme 
  	    } else {
	       cmax = max(cmax,cst)
	    }
            cs(i,j) = cst
	 }
         asol(i,j) = as
# Add 29 to make the earth's radius a multiple of 100 (6400),
# is necessary to get GMT polar projection to plot depth.
         write(2,*) acoor,r+29.,as
         if (black) {
            write(4,*) acoor,r+29.,cst
         }
      }
# make line of Moho depth and topography:
      dmh = 0
      call gett(out,col,xlat1,xlon1,ntr,tt,pp,ni,it,pt)
      do l=1,ni {
         dmh = dmh + pt(l)*sol(ioffm+it(l)) 
      }
      dmh = rmoho + 29. - 0.001*dmh
      call rotate(1,xlat1,xlon1,rlat,rlon)
      drlat = rlat/p
      drlon = rlon/p
      topo = etopo5web(drlat,drlon)
# scale topo so it's in km and (~10)x exaggerated:
      topo = radius + 29 + topoexag*0.001*topo
      acr = acoor
      if (i==1) {
         acr = 0.9999*acoor
      } 
      if(i==na) {
         acr = 1.0001*acoor
      } 
      write(11,40) acr, topo
      if (black) {
         cstm = 0.
         call gettlin(out,col,dmx,xlat1,xlon1,ntr,tt,pp,nil,itl,ptl)
	 do l=1,nil {
            cstm = cstm + ptl(l)*cols(ioffm+itl(l))
	 }
         write(10,40) acr, dmh 
      } else {
         write(10,40) acr, dmh 
      }
      call nextcoor(xlat1,xlon1,da,azimuth,xlat2,xlon2)
      acoor = acoor - dacoor
   }
   write(6,*) 'written ',slicename
   write(6,*) 'nr of nodes: ',na,nb
   write(6,*) 'spacing (degrees,km): ',dacoor,dr
   open(8,file='spacing')
   write(8,'(f9.5,"/",f9.5)') dacoor,dr
   close(8)
   close(10)
   close(11)
   write(6,*) 'written ',mohoname
   write(6,*) 'written ',toponame
   call mkclrpt(asmin,asmax)
}
if (iopt == 6) {
   # we know: xlat1 xlon1 delta azimuth rup rdown xlat2 xlon2
   j = 1
   do while (br(nba+1-j)>rdown) {
      j = j + 1
   }
   nb = j
   da = da*p
   na = nint(delta/da) + 1
   if (na > ncubelen) {
      write(6,*) "Dimension of asol exceeded!"
      stop
   }
   print*, "slicing..."
   acoor = 90. + 0.5*delta/p
   dacoor = da/p
   do i = 1,na {
      do j = 1,nb {
         as = 0.
         r = br(nba+1-j)
         call rtfxyz(0,xlat1,xlon1,r,x,y,z)
         call getc(x,y,z,r,xlat1,xlon1,nq,iq,pq,out)
         do l=1,nq {
            as = as + pq(l)*sol(ioff + iq(l))
         }
         bas = by(nba+1-j,kb)
         if (relat) {
            as = 0.1*as/bas
         } else {
            as = bas + 0.001*as
         }
         if (as>asmax) {
            asmax = as
            elamax = acoor*p
            elomax = r*p
         }
         if (as<asmin) {
            asmin = as
            elamin = acoor*p
            elomin = r*p
         }
         if (black) {
            cst = 0.
            call getclin(x,y,z,nql,iql,pql,out)
            do l=1,nql {
               cst = cst + pql(l)*cols(ioff+iql(l))
            }
            if (cst < cseps) {
               as = extreme
            } else {
               cmax = max(cmax,cst)
            }
            cs(i,j) = cst
         }
         asav(j) = asav(j) + as
      }
# make line of Moho depth and topography:
      dmh = 0
      call gett(out,col,xlat1,xlon1,ntr,tt,pp,ni,it,pt)
      do l=1,ni {
         dmh = dmh + pt(l)*sol(ioffm+it(l))
      }
      dmh = rmoho - 0.001*dmh
      call rotate(1,xlat1,xlon1,rlat,rlon)
      drlat = rlat/p
      drlon = rlon/p
      topo = etopo5web(drlat,drlon)
# scale topo so it's in km:
      topo = 0.001*topo
      topoav = topoav + topo
      dmhav = dmhav + dmh
      call nextcoor(xlat1,xlon1,da,azimuth,xlat2,xlon2)
      acoor = acoor - dacoor
   }
   topoav = topoav/na
   dmhav = dmhav/na
   do j = 1,nb {
      asav(j) = asav(j)/na
   }
   call fjmoho(nba,br,by(1,1),jjmoho)
   jjmoho = nba + 1 - jjmoho
   write(2,*) -topoav,asav(1)
   do j = 1,jjmoho-1 {
      if (br(nba+1-j)>dmhav&(radius-br(nba+1-j))>-topoav) {
         write(2,*) radius-br(nba+1-j),asav(j)
      }
   }
   write(2,*) radius-dmhav,asav(jjmoho)
   write(2,*) radius-dmhav,asav(jjmoho+1)
   do j = jjmoho+2,nb {
      if (br(nba+1-j)<dmhav) {
         write(2,*) radius-br(nba+1-j),asav(j)
      }
   }
   write(6,*) 'written ',slicename
   write(6,*) 'nr of nodes: ',na,nb
   write(6,*) 'spacing (degrees,km): ',dacoor
}
if (iopt == 3) {
   print*, "slicing..."
   if (back) {
      bas = finterp(rshell,br,by(1,kb),nba)
   }
   ea = amin - da
   do i=1,na {
      ea = ea + da
      eb = bmax + db
      do j=1,nb {
	 as = 0.
         eb = eb - db
	    elo = ea 
	    ela = eb 
         call rotate(0,ela,elo,tetaout,fiout)
	 call rtfxyz(0,tetaout,fiout,rshell,x,y,z)
         call getc(x,y,z,rshell,tetaout,fiout,nq,iq,pq,out)
         do l=1,nq {
            as = as + pq(l)*sol(ioff + iq(l))
	 }
	 if (back) {
	    if (relat) {
	       as =  0.1*as/bas
	    } else {
	       as = bas + 0.001*as
	    }
	 }
	 if (as>asmax) {
	    asmax = as
	    elamax = ela
	    elomax = elo
	 }
	 if (as<asmin) {
	    asmin = as
	    elamin = ela
	    elomin = elo
	 }
	 if (black) {
	    cst = 0.
            call getclin(x,y,z,nql,iql,pql,out)
	    do l=1,nql {
	       cst = cst + pql(l)*cols(ioff+iql(l))
	    }
	    if (cst < cseps) { 
	       as = extreme 
  	    } else {
	       cmax = max(cmax,cst)
	    }
            cs(i,j) = cst
	 }
         asol(i,j) = as
         write(2,*) elo/p,ela/p,as
      }
   }
   write(6,*) 'written ',slicename
   write(6,*) 'nr of nodes: ',na,nb
   write(6,*) 'spacing (degrees): ',da/p,db/p
   open(8,file='spacing')
   write(8,'(f9.5,"/",f9.5)') da/p,db/p
   close(8)
   call mkclrpt(asmin,asmax)
}
if (iopt == -3) {
#  this is the option for plotting crustal thickness
   print*, "slicing..."
   ea = amin - da
   do i=1,na {
      ea = ea + da
      eb = bmax + db
      do j=1,nb {
	 as = 0.
	 out = .false.
         eb = eb - db
	    elo = ea 
	    ela = eb 
         call rotate(0,ela,elo,tetaout,fiout)
         call gett(out,col,tetaout,fiout,ntr,tt,pp,ni,it,pt)
	 do l=1,ni {
            as = as + pt(l)*sol(ioff+it(l)) 
	 }
#        get the output in km rather than m of Moho anomaly:
         as = 0.001*as
	 if (back) {
	    as = as + radius - rmoho
	 }
	 if (as>asmax) {
	    asmax = as
	    elamax = ela
	    elomax = elo
	 }
	 if (as<asmin) {
	    asmin = as
	    elamin = ela
	    elomin = elo
	 }
	 if (black) {
	    cst = 0.
            call gettlin(out,col,dmx,tetaout,fiout,ntr,tt,pp,nil,itl,ptl)
	    do l=1,nil {
	       cst = cst + ptl(l)*cols(ioff+itl(l))
	    }
	    if (cst < cseps) { 
	       as = extreme 
  	    } else {
	       cmax = max(cmax,cst)
	    }
            cs(i,j) = cst
	 }
         asol(i,j) = as
         write(2,*) elo/p,ela/p,as
         if (black) {
            write(4,*) elo/p,ela/p,cst
         }
      }
   }
   write(6,*) 'written ',slicename
   write(6,*) 'nr of nodes: ',na,nb
   write(6,*) 'spacing (degrees): ',da/p,db/p
   open(8,file='spacing')
   write(8,'(f9.5,"/",f9.5)') da/p,db/p
   close(8)
   call mkclrpt(asmin,asmax)
}
if (iopt == 4) {
   print*, "rendering..."
   ipatient = 1
   ijk = 0
   z = zmin - dz
   do k = 1,nz {
      z = z + dz
      y = ymin - dy
      do j = 1,ny {
         y = y + dy
         x = xmin - dx
         do i = 1,nx {
            x = x + dx
            ijk = ijk + 1
            as = 0
            if (ijk > ipatient*50000) {
               ipatient = ipatient + 1
               write(6,*) 'processed 50000 more knots'
            }
            call rtfxyz(1,tetap,fip,rp,x,y,z)
            call getc(x,y,z,rp,tetap,fip,nq,iq,pq,out)
            do l=1,nq {
               as = as + pq(l)*sol(ioff + iq(l))
            }
	    if (back) {
               bas = finterp(rp,br,by(1,kb),nba)
	       if (relat) {
	          as = 0.1*as/bas
	       } else {
	          as = bas + 0.001*as
	       }
	    }
	    if (as>asmax) {
	       asmax = as
	       elamax = tetap
	       elomax = fip
	    }
	    if (as<asmin) {
	       asmin = as
	       elamin = tetap
	       elomin = fip
	    }
            if (black) {
               cst = 0.
               call getclin(x,y,z,nql,iql,pql,out)
               do l=1,nql {
                  cst = cst + pql(l)*cols(ioff+iql(l))
               }
               if (cst < cseps) {
                  as = extreme
               } else {
                  cmax = max(cmax,cst)
               }
               c3d(ijk) = cst
            }
            a3d(ijk) = as
         }
      }
   }
   gmax = max(asmax,-1.*asmin)
   factor = 127.5/gmax
   do ijk = 1,nsq {
      ntmp = nint(127.5 + a3d(ijk)*factor)
      ntmp = max(ntmp,0)
      ntmp = min(ntmp,255)
#      na3d(ijk) = ntmp
      na3d(ijk) = char(ntmp)
   }
   do ijk = 1,nsq {
      ierr = fputc(2,na3d(ijk))
   }
   open(9,file='Bobfile')
   rewind 9
   write(9,*) "size = ",nx,ny,nz
   write(9,*) "file = ",slicename
   write(9,*) "color = rainbow.palette"
   close(9)
   if (black) {
      factor = 254./cmax
      do ijk = 1,nsq {
#         nc3d(ijk) = nint(c3d(ijk)*factor)
         nc3d(ijk) = char(nint(c3d(ijk)*factor))
      }
      do ijk = 1,nsq {
         ierr = fputc(4,nc3d(ijk))
      }
   }
}
if (iopt == 5) {
   print*, "rendering..."
   ipatient = 1
   ijk = 0
   r = rdown - dr
   do k = 1,nr {
      r = r + dr
      a = amin - da
      do j = 1,na {
         a = a + da
         b = bmin - db
         do i = 1,nb {
            b = b + db
            ijk = ijk + 1
            as = 0
            if (ijk > ipatient*50000) {
               ipatient = ipatient + 1
               write(6,*) 'processed 50000 more knots'
            }
	    call rotate(0,a,b,teta,fi)
            call rtfxyz(0,teta,fi,r,x,y,z)
            call getc(x,y,z,r,teta,fi,nq,iq,pq,out)
            do l=1,nq {
               as = as + pq(l)*sol(ioff + iq(l))
            }
	    if (back) {
               bas = finterp(r,br,by(1,kb),nba)
	       if (relat) {
	          as = 0.1*as/bas
	       } else {
	          as = bas + 0.001*as
	       }
	    }
	    if (as>asmax) {
	       asmax = as
	       elamax = teta
	       elomax = fi
	    }
	    if (as<asmin) {
	       asmin = as
	       elamin = teta
	       elomin = fi
	    }
            if (black) {
               cst = 0.
               call getclin(x,y,z,nql,iql,pql,out)
               do l=1,nql {
                  cst = cst + pql(l)*cols(ioff+iql(l))
               }
               if (cst < cseps) {
                  as = extreme
               } else {
                  cmax = max(cmax,cst)
               }
               c3d(ijk) = cst
            }
            a3d(ijk) = as
         }
      }
   }
   gmax = max(asmax,-1.*asmin)
   factor = 127.5/gmax
   do ijk = 1,nsq {
      ntmp = nint(127.5 + a3d(ijk)*factor)
      ntmp = max(ntmp,0)
      ntmp = min(ntmp,255)
#      na3d(ijk) = ntmp
      na3d(ijk) = char(ntmp)
   }
   do ijk = 1,nsq {
      ierr = fputc(2,na3d(ijk))
   }
   open(9,file='Bobfile')
   rewind 9
   write(9,*) "size = ",nb,na,nr
   write(9,*) "file = ",slicename
   write(9,*) "color = rainbow.palette"
   close(9)
   if (black) {
      factor = 254./cmax
      do ijk = 1,nsq {
#         nc3d(ijk) = nint(c3d(ijk)*factor)
         nc3d(ijk) = char(nint(c3d(ijk)*factor))
      }
      do ijk = 1,nsq {
         ierr = fputc(4,nc3d(ijk))
      }
   }
}
   
if (black) {
   write(6,*) 'colsm max: ',cmax 
}
write(6,*) 'asmin, asmax: ',asmin,asmax
write(6,*) 'at:',elamin/p,elomin/p,' and ',elamax/p,elomax/p

write(6,*) 'sns finished'
end

subroutine mkclrpt(asmin,asmax)
define ncolors 10
dimension lors(3,ncolors)
data (lors(i,1),i=1,3)/170,0,0/
data (lors(i,2),i=1,3)/255,0,0/
data (lors(i,3),i=1,3)/255,85,0/
#data (lors(i,4),i=1,3)/255,170,0/
data (lors(i,4),i=1,3)/255,128,0/
data (lors(i,5),i=1,3)/255,255,0/
data (lors(i,6),i=1,3)/255,255,0/
#data (lors(i,7),i=1,3)/90,255,30/
data (lors(i,7),i=1,3)/30,220,100/
#data (lors(i,8),i=1,3)/0,240,110/
data (lors(i,8),i=1,3)/0,225,140/
data (lors(i,9),i=1,3)/0,80,255/
data (lors(i,10),i=1,3)/0,0,205/

40 format(f10.2,3i4,2x,f10.2,3i4)
41 format(f10.2,3i4,2x,f10.2,3i4,1x,a1)
limu = nint(max(abs(asmax),abs(asmin)))
liml = -1*limu
write(6,*) 'liml, limu: ',liml,limu
dlim = 2.*limu/(ncolors-1.)
open(3,file='color.palette')
rewind 3
v1 = liml
v0 = v1
v1 = v1 + dlim
write(3,41) v0,lors(1,1),lors(2,1),lors(3,1),v1,lors(1,2),lors(2,2),lors(3,2),'U'
do icl=2,ncolors-1 {
   v0 = v1
   v1 = v1 + dlim
   write(3,40) v0,lors(1,icl),lors(2,icl),lors(3,icl),v1,lors(1,icl+1),lors(2,icl+1),lors(3,icl+1)
}
return
end

       function finterp(x,xa,ya,n)
       dimension xa(n), ya(n)
# to linearly interpolate for y between two pairs (x,y)
# from the given input arrays. 

       i = 1
       j = i+1
       do while ((j<=n) & (x<min(xa(i),xa(j)) | x>max(xa(i),xa(j)))) {
          i = j
          j = i+1
       }
       if (j>n) {
	  write(6,*) 'Error: ',x,' not in array'
	  finterp = 0.
	  return
       }
       abs1 = abs(1.-xa(i)/x)
       abs2 = abs(1.-xa(i-1)/x)
       if (i>1) { if (abs1<1.e-6 & abs2<1.e-6) { 
          finterp = 0.5*(ya(i) + ya(i-1)) 
          return
       }}
       abs1 = abs(1.-xa(i)/x)
       abs2 = abs(1.-xa(i+1)/x)
       if (i<n) { if (abs1<1.e-6 & abs2<1.e-6) { 
	  finterp = 0.5*(ya(i) + ya(i+1)) 
          return
       }}
       abs1 = abs(1.-xa(j)/x)
       abs2 = abs(1.-xa(j-1)/x)
       if (j>1) { if (abs1<1.e-6 & abs2<1.e-6) { 
          finterp = 0.5*(ya(j) + ya(j-1)) 
          return
       }}
       abs1 = abs(1.-xa(j)/x)
       abs2 = abs(1.-xa(j+1)/x)
       if (j<n) { if (abs1<1.e-6 & abs2<1.e-6) { 
	  finterp = 0.5*(ya(j) + ya(j+1)) 
          return
       }}
       x0 = xa(i)
       y0 = ya(i)
       x1 = xa(j)
       y1 = ya(j)
       finterp = (x-x0)*(y1-y0)/(x1-x0) + y0
       return
       end

subroutine fjmoho(n,r,vp,jjmoho)
include slicedefs

dimension r(n),vp(n)

jjmoho = 0
i=n
do while (vp(i)<4) {
   i=i-1 }
do while ((vp(i-1)-vp(i))<=1.2) {
   i=i-1}
if (r(i)==r(i-1)) { jjmoho = i }
write(6,*) ''
write(6,*) "moho depth?: ", radius - 0.001*r(jjmoho)," km"

return
end

