program thsmcomb
# c. SVDL & TD
#
#
# this program computes a matrix for point crustal thickness constraints
# it is glued to the original matrix by program "glue.r" and dnv3e.r 
# is run finally to invert for crustal thickness from surface waves 
# with additional point crustal thickness constraints. 
# 
include defines
include sdefines
dimension tt(mxtr),pp(mxtr),jy(nrfpr),apu(nrfpr),jn(nrfpr),it(nonzsm),pt(nonzsm)
dimension wc(kmax)
logical out
character*72 pdfn
common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,xmin,xmax,dz,dy,dx
common/smooth/st,step,ksteps,mazi,w0,wc

open(1,file='model.shell',status='old')
rewind 1
read(1,*)ntr,nt,imx,dmxd,cold,rmoho
write(6,*)'reading model.shell'
write(6,*)'ntr,nt,imx,dmxd,cold,rmoho',ntr,nt,imx,dmxd,cold,rmoho
refmohodep=(radius-rmoho)
read(1,*) (tt(k),k=1,ntr)
read(1,*) (pp(k),k=1,ntr)
close (1)
#convert to radians
dmx = dmxd*p
col = cold*p

call setgrid(ddd,avdd,distmax)

call setpar(njy,jy,apu,njn,jn,jmoho,apu5)
#write(6,*)'apu5',apu5
inofset = nsq*njy
narg = iargc()
if (narg != 1) {print*, "Usage: thsmcomb pointdatafile"; stop }
call getarg(1,pdfn)
#open(3,file='pointdata', status='old')
open(3,file=pdfn, status='old')
rewind 3
read(3,*) nd

open(4,file='tmatrix',status='new')
rewind 4

open(7,file='trhs',status='new')
rewind 7
#write(7,*)nd

open(8,file='smooth',status='old')
rewind 8
read(8,*)stk,st,step,ksteps,mazi,w0,(wc(k),k=1,ksteps)
write(6,*)'reading smooth....'
write(6,*)stk,st,step,ksteps,mazi,w0,(wc(k),k=1,ksteps)

idata=0
do i=1,nd  {
  out=.false.
  read(3,*)plat,plon,pot
  write(6,*)'reading points.....'
  write(6,*)plat,plon,pot
  # proceed in radians:
  plat=plat*p
  plon=plon*p
  call rotate(0,plat,plon,elat,elon)
  rmo=radius-pot
  write(6,*)'rotated coordinates'
  write(6,*)elat/p,elon/p,rmo
  call rtfxyz(0,elat,elon,rmoho,x,y,z)
  write(6,*)'x,y,z',x,y,z
  if(x < xmin | x > xmax | y < ymin | y > ymax | z < zmin | z > zmax) out=.true.
  call gett(out,col,elat,elon,ntr,tt,pp,ntl,it,pt)
#  do k=1,ntl {
#    pt(k)=apu5*pt(k)
#  }
    
  write(6,*)'out,col,elat,elon',out,col,elat,elon
  write(6,*)'ntl',ntl

  if(ntl>0) {
    idata=idata+1   
    write(4,*) idata,1,ntl
    write(4,*) (it(j)+inofset,j=1,ntl)
    write(4,*) (pt(j),j=1,ntl)
    pot=pot-refmohodep
    pot=pot*1000.
    write(7,*)pot 
  }
}
print*, 'idata=',idata

end
