      subroutine trids(ds,dd,teta1,fi1,teta2,fi2,teta,fi,teta0,fi0)
* assumes input in radians. teta is latitude, fi is longitude.
* trids computes perpendicular distance (in radians) from teta,fi 
* to great circle between teta1,fi1 and teta2,fi2.

      dimension s(3),r(3),sr(3),p(3)

      ct1 = cos(teta1)
      st1 = sin(teta1)
      cf1 = cos(fi1)
      sf1 = sin(fi1)
      ct2 = cos(teta2)
      st2 = sin(teta2)
      cf2 = cos(fi2)
      sf2 = sin(fi2)
      ct = cos(teta)
      st = sin(teta)
      cf = cos(fi)
      sf = sin(fi)
      ct0 = cos(teta0)
      st0 = sin(teta0)
      cf0 = cos(fi0)
      sf0 = sin(fi0)
      s(1) = ct1*cf1
      s(2) = ct1*sf1
      s(3) = st1
      r(1) = ct2*cf2
      r(2) = ct2*sf2
      r(3) = st2
      call outp(sr,s,r)
      call normalize(sr)

      p(1) = ct*cf
      p(2) = ct*sf
      p(3) = st
      call inp(psr,p,sr)
*     asin because the inner product gives the cosine of pi/2-ds:
      ds = asin(psr)
      ds = abs(ds)

      p(1) = ct0*cf0
      p(2) = ct0*sf0
      p(3) = st0
      call inp(psr,p,sr)
      dd = asin(psr)
      dd = abs(dd)

      return
      end

      subroutine inp(z,a,b)
      dimension a(3),b(3)
      z = a(1)*b(1) + a(2)*b(2) + a(3)*b(3)
      return
      end

      subroutine outp(z,a,b)
      dimension a(3),b(3),z(3)
      z(1) = a(2)*b(3) - a(3)*b(2)
      z(2) = a(3)*b(1) - a(1)*b(3)
      z(3) = a(1)*b(2) - a(2)*b(1)
      return
      end

      subroutine normalize(a)
      dimension a(3)
      alength = sqrt(a(1)*a(1) + a(2)*a(2) + a(3)*a(3))
      do i=1,3 
	 a(i) = a(i)/alength
      enddo
      return
      end
