program vint
# to integrate the S-velocities vertically 
# c 1995 Suzan vd Lee

include workdefs
include worklims
include sdefines
include slicedefs

dimension pq(nonzsm),iq(nonzsm)
dimension pt(nonzsm),it(nonzsm)
character*15 txt(nrfpr)
character*27 argv
character*47 file
character*30 solution
dimension jy(nrfpr),jn(nrfpr),apu(nrfpr)
dimension tt(mxtr),pp(mxtr)
dimension sol(nminv)
dimension r0(10,100),v0(10,100)
dimension wc(kmax)
dimension nr(10)
logical out
data txt/'P-wave velocity','S-wave velocity','density','Shear Quality','Moho depth'/
data argv/'/data2/suzan/na/final/inv4/'/
# background model MC35:
data nreg/5/
data nr/26,41,6,6,3,0,0,0,0,0/
data (r0(1,i),i=1,26)/5701., 5711., 5721., 5731., 5741., 5751., 5761., 5771.,
5781., 5791., 5801., 5811., 5821., 5831., 5841., 5851., 5861., 5871., 5881.,
5891., 5901., 5911., 5921., 5931., 5941., 5951./
data (r0(2,i),i=1,41)/ 5951., 5961., 5971., 5981., 5991., 6001., 6011.,
6021., 6031., 6041., 6051., 6061., 6071., 6081., 6091., 6101., 6111., 6121.,
6131., 6141., 6151., 6161., 6171., 6181., 6191., 6201., 6211., 6221., 6231., 6241.,
6251., 6261., 6271., 6281., 6291., 6301., 6311., 6321., 6326., 6331., 6336./
data (r0(3,i),i=1,6)/ 6336., 6339., 6342., 6345., 6348., 6351./
data (r0(4,i),i=1,6)/ 6351., 6355., 6359., 6363., 6366., 6369./
data (r0(5,i),i=1,3)/ 6369., 6370., 6371./
data (v0(1,i),i=1,26)/ 5.47142 , 5.45463 , 5.43784 , 5.42105 , 5.40425 , 5.38746 ,
5.37067 , 5.35388 , 5.33709 , 5.32030 , 5.30351 , 5.28672 , 5.26993 , 5.25314 ,
5.23635 , 5.21956 , 5.20277 , 5.18598 , 5.16919 , 5.15240 , 5.13561 , 5.11882 ,
5.10202 , 5.08523 , 5.06844 , 5.05165 /
data (v0(2,i),i=1,41)/ 4.81571 , 4.80108 , 4.78645 , 4.77182 , 4.75719 , 4.74256 ,
4.72793 , 4.71330 , 4.69867 , 4.68404 , 4.66940 , 4.65477 , 4.64014 , 4.62551 ,
4.61088 , 4.59625 , 4.58162 , 4.56699 , 4.55236 , 4.53773 , 4.52310 , 4.50000 ,
4.50000 , 4.50000 , 4.50000 , 4.50000 , 4.50000 , 4.50000 , 4.50000 , 4.50000 ,
4.50000 , 4.50000 , 4.50000 , 4.50000 , 4.50000 , 4.50000 , 4.50000 , 4.50000 ,
4.50000 , 4.50000 , 4.50000 /
data (v0(3,i),i=1,6)/ 3.75000 , 3.75000 , 3.75000 , 3.75000 , 3.75000 , 3.75000 /
data (v0(4,i),i=1,6)/ 3.45000 , 3.45000 , 3.45000 , 3.45000 , 3.45000 , 3.45000 /
data (v0(5,i),i=1,3)/ 3.00000 , 3.00000 , 3.00000 /
common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,xmin,xmax,dz,dy,dx
common/smooth/st,step,ksteps,mazi,w0,wc

write(6,*) 'program vint:'
10 format(a,$ )
70 format(2f8.2,f6.0,4f7.2)

solution='sol.d=14.s=01.15'
write(6,*) solution

open(7,file='output')
rewind 7
write(7,*) 'lat, lon, elev, dts, dtm, dte, total delay'

file = argv//'model.cube'
open(1,file=file,status='old')
rewind 1
read(1,*) ola,olo,oazi,nz,ny,nx,zmin,zmax,ymin,ymax,xmin,xmax,dz,dy,dx
close(1)
ola = ola*p
olo = olo*p
oazi = oazi*p
nxy = nx*ny
nsq = nxy*nz

#get correlation length for smoothing:
file = argv//'smooth'
open(2,file=file,status='old')
rewind 2
read(2,*) stk,st,step,ksteps,mazi,w0,(wc(k),k=1,ksteps)
close(2) 

file = argv//'parcom'
call setparf(file,njy,jy,apu,njn,jn,jmoho,apu5)

write(6,*) 'reading NA-model'
file = argv//solution
open(1,file=file,status='old')
rewind 1
read(1,*) mnnn
read(1,*) (sol(i),i=1,mnnn)
close(1)

file = argv//'model.shell'
open(1,file=file,status='old')
rewind 1
read(1,*) ntr,nt,imx,dmxd,cold,rmoho
read(1,*) (tt(k),k=1,ntr)
read(1,*) (pp(k),k=1,ntr)
close(1)
col=cold*p
dmx = dmxd*p

j=1
ioffs=0
do while (jy(j) != 2) {
   j=j+1
   ioffs = ioffs + nsq
}
ioffm = njy*nsq

range = 660.
rup = radius
rdown = rup - range
ddd = min(dx,dy,dz)
dkm = 0.1*ddd
ndr = nint(range/dkm)
dr = range/ndr
ndr = ndr + 1

write(6,*) ''
write(6,*) 'give latitude, longitude and elevation (in m) of point (station)'
write(6,10) '(stop on 99): '
read(5,*) at,on,elev
write(6,*) 'point: ',at,on,elev

open(3,file='sdevs')
rewind 3

do while (at < 99.) {

   tts = 0.
   alat = at*p
   alon = on*p
   call rotate(0,alat,alon,teta,fi)

#  contribution from S-anomalies (relative to MC35):
   dts = 0.
   ts = 0.
   ats = 0.

   do j=1,nreg {

      r = r0(j,1)
      vel0 = v0(j,1)
      call rtfxyz(0,teta,fi,r,x,y,z)
      call getc(x,y,z,r,teta,fi,nq,iq,pq,out)
      asol = 0.
      do l=1,nq {
         asol = asol + pq(l)*sol(ioffs + iq(l))
      }
      dvel = asol*0.001
      vel = vel0 + dvel
      write(3,*) radius-r,vel
      dr = 0.5*(r0(j,2) - r)
      ts = ts + dr/vel0
      ats = ats + dr/vel

      do i=2,nr(j)-1 {
	 r = r0(j,i)
	 vel0 = v0(j,i)
         call rtfxyz(0,teta,fi,r,x,y,z)
         call getc(x,y,z,r,teta,fi,nq,iq,pq,out)
         asol = 0.
         do l=1,nq {
            asol = asol + pq(l)*sol(ioffs + iq(l))
         }
         dvel = asol*0.001
	 vel = vel0 + dvel
         write(3,*) radius-r,vel
	 dr = 0.5*(r0(j,i+1) - r0(j,i-1))
	 ts = ts + dr/vel0
	 ats = ats + dr/vel
      }

      r = r0(j,nr(j))
      vel0 = v0(j,nr(j))
      call rtfxyz(0,teta,fi,r,x,y,z)
      call getc(x,y,z,r,teta,fi,nq,iq,pq,out)
      asol = 0.
      do l=1,nq {
         asol = asol + pq(l)*sol(ioffs + iq(l))
      }
      dvel = asol*0.001
      vel = vel0 + dvel
      write(3,*) radius-r,vel
      dr = 0.5*(r0(j,nr(j)) - r0(j,nr(j)-1))
      ts = ts + dr/vel0
      ats = ats + dr/vel
   }

      write(6,*) 'MC35 travel time: ',ts,' s'
      write(6,*) 'NA travel time: ',ats,' s'
      dts = ats - ts

      write(6,*) 'travel time through S-anomalies = ',dts,' s'
      tts = tts + dts

# contribution from Moho deviation (in MC35):
   if (jy(njy+1) == 5) {
      vup = 3.750
      vdown = 4.500
      call gett(out,col,teta,fi,ntr,tt,pp,ni,it,pt)
      asol = 0.
      do l=1,ni {
            asol = asol + pt(l)*sol(ioffm + it(l))
      }
      dh = asol*0.001
      dtm = dh/vup - dh/vdown
      write(6,*) 'delay from Moho deviation = ',dtm,' s  for',dh,' km'
      tts = tts + dtm 
   }

#  contribution from elevation:
   vsurf = 3000.
   dte = elev/vsurf
   write(6,*) 'delay from elevation = ',dte,' s'
   tts = tts + dte

   write(6,*) 'total upper mantle travel time (relative to MC35) = ', tts,' s'
   write(6,*) ''

   write(7,70) at,on,elev,dts,dtm,dte,tts
   
   write(6,*) 'give latitude, longitude and elevation of point (station)'
   write(6,10) '(stop on 99): '
   read(5,*) at,on,elev
   write(6,*) 'point: ',at,on,elev
}

end

subroutine setparf(file,njy,jy,apu,njn,jn,jmoho,apu5)
include defines

dimension jy(nrfpr),jn(nrfpr),apu(nrfpr)
character*(*) file
logical compl

open(2,file=file,status='old')
rewind 2
   read(2,*) njy
   read(2,*) (jy(j),j=1,njy)
   read(2,*) (apu(j),j=1,njy)
close(2)

im = 0
do i=1,njy {
   if (jy(i) == 5) { im=i }
}

if (im != 0) {
   jmoho = 1
   apu5 = apu(im)
   njy = njy - 1
   do i=im,njy {
      jy(i) = jy(i+1)
      apu(i) = apu(i+1) }
}

ii=1
do i=1,4 {
   compl=.true.
   do j=1,njy { if (jy(j)==i) compl=.false. }
   if (compl) { jn(ii)=i; ii=ii+1 }
}

njn=4-njy
if ((ii-1) != njn) { write(6,*) "error in njn/jn"; stop }

write(6,*) ''
write(6,*) njy," parameters:",(jy(j),j=1,njy)
write(6,*) "    with a priori uncertainties:",(apu(j),j=1,njy)
write(6,*) njn," non-parameters:",(jn(j),j=1,njn)
if (jmoho == 1) {
   write(6,*) 'moho-depth is parameter with a priori uncertainty:', apu5 }
else {
   write(6,*) 'moho-depth is non-parameter' }
write(6,*) ''

return
end


subroutine rotate(mode,tetain,fiin,tetaout,fiout)
include defines
# mode 0, rotate from conventional to new
# mode 1, rotate from new to conventional
common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,xmin,xmax,dz,dy,dx

#if (ola < -0.5*pi | ola > 0.5*pi) {
#   write(6,*) "origin latitude badly defined: ",ola/p } 
#if (tetain < -0.5*pi | tetain > 0.5*pi) {
#   write(6,*) "event/station latitude badly defined: ",tetain/p } 

if (mode == 0) {
   ang1 = olo
   ang2 = oazi
} else if (mode == 1) {
   ang2 = olo
   ang1 = oazi
} else {
  tetaout = tetain
  fiout = fiin
  mode = -1
  return
}

ct = cos(tetain)
st = sin(tetain)
cf = cos(fiin)
sf = sin(fiin)
ca = cos(ola)
sa = sin(ola)
co = cos(ang1)
so = sin(ang1)
som = ct*ca*(cf*co + sf*so) + st*sa
tetaout = asin(som) 
fdiff = fiin - ang1
sfo = sin(fdiff)
cfo = cos(fdiff)
teller = ct*sfo
rnoemer = st*ca - ct*sa*cfo
azimuth = atan2(teller,rnoemer)
fiout = ang2 - azimuth

return
end


subroutine getc(xp,yp,zp,rp,tp,fp,np,i,f,out)
include defines
include sdefines
dimension i(nonzsm),f(nonzsm)
dimension i8(nlin),f8(nlin)
dimension wc(kmax)
logical out
common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,xmin,xmax,dz,dy,dx
common/smooth/st,step,ksteps,mazi,w0,wc

# xyz grid counts from top layer, node 1 is at xmin,ymax and
# node nx is at xmax,ymax. node nx+1 is at xmin,ymax-1, etc. till
# node nx*ny. Next node is at z-1, xmin,ymax, etc.

np = 0
do l = 1,nonzsm { i(l) = 0; f(l) = 0. }

r0 = rp
t0 = tp
f0 = fp
x0 = xp
y0 = yp
z0 = zp

# check if x,y,z, is inside square grid:
# if not, return zero.
out = .false.
if (x0 < xmin | x0 > xmax | y0 < ymin | y0 > ymax | z0 < zmin | z0 > zmax) {
   out = .true. 
   return
}

call trilin(x0,y0,z0,n8,i8,f8)
do l=1,n8 {
   call addif(i8(l),f8(l),w0,np,i,f)
}

na = 0
dcst = 0.
az = 0.
daz = 4.*pi/mazi
do k = 1,ksteps {
   na = na + mazi
   daz = 0.5*daz
   az = az + 0.5*daz
   dcst = dcst + step
   wk = wc(k)
   do ia = 1,na {
      az = az + daz
      call fiteta(f1,t1,f0,t0,az,dcst)
      call rtfxyz(0,t1,f1,r0,x1,y1,z1)
      call trilin(x1,y1,z1,n8,i8,f8)
      do l=1,n8 {
         call addif(i8(l),f8(l),wk,np,i,f)
      }
   }
}

return
end

subroutine trilin(xq,yq,zq,n8,i8,f8)
dimension i8(nlin),f8(nlin)
common/grid/ola,olo,oazi,nsq,nxy,nz,ny,nx,zmin,zmax,ymin,ymax,xmin,xmax,dz,dy,dx

if (xq < xmin | xq > xmax | yq < ymin | yq > ymax | zq < zmin | zq > zmax) {
   n8 = 0
   return
} else {
   n8 = nlin
}

xdist = (xq - xmin)/dx
ydist = (ymax - yq)/dy
zdist = (zmax - zq)/dz

# coordinates of upper left back corner:
ixmn = int(xdist) + 1
ixmx = ixmn + 1
if (ixmn == nx) { ixmx = ixmn; ixmn = ixmx - 1 } 
iymn = int(ydist) + 1
iymx = iymn + 1
if (iymn == ny) { iymx = iymn; iymn = iymx - 1 }
izmn = int(zdist) + 1
izmx = izmn + 1
if (izmn == nz) { izmx = izmn; izmn = izmx - 1 }

lub = (izmn-1)*nxy + (iymn-1)*nx + ixmn 
i8(1) = lub
i8(2) = lub + 1
i8(3) = lub + nx
i8(4) = i8(3) + 1
i8(5) = lub + nxy
i8(6) = i8(5) + 1
i8(7) = i8(5) + nx
i8(8) = i8(7) + 1

# relative distance of point to 3 sides of cell:
x = xdist - (ixmn-1)
y = (iymx-1) - ydist
z = (izmx-1) - zdist

xy = x*y
xz = x*z
yz = y*z
xyz = xy*z

f8(1) = yz - xyz
f8(2) = xyz
f8(3) = z - yz - xz + xyz
f8(4) = xz - xyz
f8(5) = y - xy - yz + xyz
f8(6) = xy - xyz
f8(7) = 1 - x - y - z + xy + yz + xz - xyz
f8(8) = x - xy - xz + xyz

# 1 cube:
#
#        1________2 
#        /       /|
#      3/______4/ |
#       | |_____|_|6 
#       |/5     |/ 
#      7/_______/8 
#
#
# the index of a node:  i = (iz-1)*nx*ny + (iy-1)*nx + ix

return
end

subroutine wrers(xp,yp,zp,x,y,z)
   write(6,*) "DANGER: path is not completely in grid:"
   write(6,*) "x was ",xp," y was ",yp," z was ",zp
   write(6,*) "x is ",x," y is ",y," z is ",z
   write(6,*) "outward structure set to zero."
return
end

subroutine addif(iin,fin,wt,n,iarr,farr)
include sdefines
dimension iarr(nonzsm), farr(nonzsm)

jl = 0
ju = n + 1
do while ((ju-jl) > 1) {
   jm = (ju+jl)/2
   if (iin > iarr(jm)) jl = jm
   else ju = jm
}
# this gives jl and ju so that iarr(jl) < iin <= iarr(ju)

if (iin == iarr(ju)) {
   farr(ju) = farr(ju) + wt*fin
} else {
   n = n + 1
   do j = n,ju+1,-1 {
      iarr(j) = iarr(j-1)
      farr(j) = farr(j-1)
   }
   iarr(ju) = iin
   farr(ju) = wt*fin
}

return
end

subroutine gett(out,col,ela,elo,ntr,tt,pp,nl,i,f)
include defines
include sdefines
dimension tt(mxtr), pp(mxtr)
dimension i(nonzsm), f(nonzsm) 
dimension ds(nonzsm),wt(nonzsm)
dimension ka(12000)
dimension wc(kmax)
logical out
common/smooth/st,step,ksteps,mazi,w0,wc

# determine if node inside area:
range = 0.5*pi - ela
if (range > col | out) {
   #write(6,*) 'warning: coordinates fall OUTSIDE triangular grid'
   out = .true.
   nl = 0
   return
}

# determine closed-in area in which to search for closest nodes:
de = st*2
range = 0.5*pi - de
tmin = ela - de
cela = cos(ela)
  
ik = 0
if (ela > range) {
   do k = 1,ntr {
      if (tt(k) >= tmin) {
         ik = ik + 1
         ka(ik) = k
      }
   }
} else {
   do k = 1,ntr {
      ttabs = abs (tt(k) - ela)
      if (ttabs <= de) {
         ppelo = pp(k) - elo
         ppabs = min(abs(ppelo),abs(ppelo+2.*pi),abs(ppelo-2.*pi))
	 ppabs = ppabs*cela
         if (ppabs <= de) {
            ik = ik + 1
            ka(ik) = k
         }
      }
   }
}
nk = ik
if (nk == 0) { 
   #write(6,*) 'ERROR: nk = 0! for:',ela/p,elo/p 
   nl = 0
   return
}

 
# find a number (nl) of closest vertices:
nl = 0
do ik=1,nk {
   call deltas(delta,tt(ka(ik)),pp(ka(ik)),ela,elo)
   if (delta < st) { 
      nl = nl+1
      ds(nl) = delta      
      i(nl) = ka(ik)
   }
}

if (nl > nonzsm) {
   write(6,*) 'ERROR: nl >',nonzsm,' for ela,elo = ',ela/p,elo/p
   write(6,*) 'array dimension exceeded!'
} 

# choose linear basis functions and
# weight the total influence of these vertices to 1:
wsum = 0
do l=1,nl {
   wt(l) = (st - ds(l))/st
   wsum = wsum + wt(l)
}
do l=1,nl {
   f(l) = wt(l)/wsum
}

return
end

subroutine rtfxyz(mode,teta,fi,r,x,y,z)
include defines
# teta = latitude, fi = longitude, relative to new (rotated)
# northpole and equator. r = distance from Earth's center (0,0,0).
# if mode=0 r,teta,fi --> x,y,z
# if mode=1 x,y,z --> r,teta,fi

if (mode == 0) {
   ct = cos(teta)
   x = r*ct*cos(fi)
   y = r*ct*sin(fi)
   z = r*sin(teta)
} else if (mode == 1) {
   x2 = x*x
   y2 = y*y
   z2 = z*z
   r = sqrt(x2 + y2 + z2)
   fi = atan2(y,x)
   teta = atan2(z,sqrt(x2 + y2))
} else {
   x=0;y=0;z=0
   r=0;teta=0;fi=0
   mode=-1
}

return
end

subroutine fiteta(fi2,teta2,fi1,teta1,azimuth,delta)

        cd = cos(delta)
        sd = sin(delta)
	cf = cos(fi1)
	sf = sin(fi1)
	ct = cos(teta1)
	st = sin(teta1)
	ca = cos(azimuth)
	sa = sin(azimuth)

	cdct = cd*ct
	sdca = sd*ca
	sdcast = sdca*st
	sdsa = sd*sa

	t1 = cdct*sf
	t2 = sdcast*sf
	t3 = sdsa*cf
	teller = t1 - t2 + t3
	t1 = cdct*cf
	t2 = sdcast*cf
	t3 = sdsa*sf
	rnoemer = t1 - t2 - t3
	fi2 = atan2(teller,rnoemer)
	t1 = cd*st
	t2 = sdca*ct
	som = t1 + t2
	teta2 = asin(som)

	return
	end

subroutine deltas(delta,teta1,fi1,teta2,fi2)

	term1  = sin(teta1)*sin(teta2)
	factor2  = cos(teta1)*cos(teta2)
	factor1 = cos (fi1 - fi2)
	term2 = factor1*factor2
	som = term1 + term2
	delta = acos (som)
	return
	end

subroutine trids(ds,dd,teta1,fi1,teta2,fi2,teta,fi,teta0,fi0)
# assumes input in radians. teta is latitude, fi is longitude.
# trids computes perpendicular distance (in radians) from teta,fi 
# to great circle between tea1,fi1 and teta2,fi2.
# SL, 1994

      dimension s(3),r(3),sr(3),pp(3)

      ct1 = cos(teta1)
      st1 = sin(teta1)
      cf1 = cos(fi1)
      sf1 = sin(fi1)
      ct2 = cos(teta2)
      st2 = sin(teta2)
      cf2 = cos(fi2)
      sf2 = sin(fi2)
      ct = cos(teta)
      st = sin(teta)
      cf = cos(fi)
      sf = sin(fi)
      ct0 = cos(teta0)
      st0 = sin(teta0)
      cf0 = cos(fi0)
      sf0 = sin(fi0)
      s(1) = ct1*cf1
      s(2) = ct1*sf1
      s(3) = st1
      r(1) = ct2*cf2
      r(2) = ct2*sf2
      r(3) = st2
      call outp(sr,s,r)
      call normalize(sr)

      pp(1) = ct*cf
      pp(2) = ct*sf
      pp(3) = st
      call inp(psr,pp,sr)
#     asin because the inner product gives the cosine of pi/2-ds:
      ds = asin(psr)
      ds = abs(ds)

      pp(1) = ct0*cf0
      pp(2) = ct0*sf0
      pp(3) = st0
      call inp(psr,pp,sr)
      dd = asin(psr)
      dd = abs(dd)

      return
      end

      subroutine inp(z,a,b)
      dimension a(3),b(3)
      z = a(1)*b(1) + a(2)*b(2) + a(3)*b(3)
      return
      end

      subroutine outp(z,a,b)
      dimension a(3),b(3),z(3)
      z(1) = a(2)*b(3) - a(3)*b(2)
      z(2) = a(3)*b(1) - a(1)*b(3)
      z(3) = a(1)*b(2) - a(2)*b(1)
      return
      end

      subroutine normalize(a)
      dimension a(3)
      alength = sqrt(a(1)*a(1) + a(2)*a(2) + a(3)*a(3))
      do i=1,3  {
	 a(i) = a(i)/alength
      }
      return
      end
